/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:22 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torplatform_h__
#define __torplatform_h__

#define TOR_VERSION 300

// Platform specific build settings for the TOR library.

#ifdef _MSC_VER
// Windows
#ifdef TOR_DLL
// Defined when using TOR as a dynamic (shared) library
// Only definitions intended to be used by TOR clients are exported.
#   ifdef TOR_DLL_EXPORT
// Defined when a file in TOR is compiled
#       define TOR_EXT_DEF __declspec(dllexport)
#       define TOR_EXTERN_TEMPLATE_INST
#   else
// Defined when a file outside TOR is compiled
#       define TOR_EXT_DEF __declspec(dllimport)
#       define TOR_EXTERN_TEMPLATE_INST extern
#   endif

#pragma warning( disable : 4251 )
// class 'name' needs to have dll-interface to be used by clients of class 'name'

#else
#   define TOR_EXT_DEF 
#endif

#pragma warning( disable : 4290 )
// C++ exception specification ignored except to indicate a function is not __declspec(nothrow)
# pragma warning( disable : 4290 )
// identifier was truncated to '255' characters in the debug information
# pragma warning( disable : 4786 )
#pragma warning( disable : 4786 )
#else

// Unix

// Defined when using TOR as a dynamic (shared) library
// All definitions are exported (i.e. no difference than with a static library)
#   define TOR_EXT_DEF

# ifdef _UNICODE
#  define _stprintf swprintf
#  define _tcscmp wcscmp
# else
#  define _stprintf sprintf
#  define _tcscmp strcmp
# endif
#endif

// This is the main switch between the integration operating systems.
// The define TGTOS is used for switching integration.

#define OS_USER     (0x0100)
#define OS_WIN32    (0x0200)
#define OS_LINUX    (0x0300)
#define OS_SOLARIS  (0x0400)

#ifndef TGTOS
// We use the host system.
#  if defined( sun )
#    define TGTOS OS_SOLARIS
#  elif defined( __linux )
#    define TGTOS OS_LINUX
#  elif defined(_WIN32)
#    define TGTOS OS_WIN32
#  else
#    error "Must set TGTOS explicitly for now"
#  endif
#endif


#ifndef TOR_USE_WSTRING
#  define TOR_USE_WSTRING (1)
#endif



#ifndef TOR_USE_PUTENV
#  define TOR_USE_PUTENV (1)
#endif


#ifndef TOR_USE_OSTREAM
#  define TOR_USE_OSTREAM (1)
#endif

#endif // __torplatform_h__

