# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
proc RemoveDependency { models root } {
    foreach model $models {
        set dependencies [u2::GetEntities $model ClientDependency]
        foreach dependency $dependencies {
            set supplier [u2::GetValue $dependency Supplier]
            if { [catch { [u2::GetMetaclassName $supplier] } e ] } {
                # this is unbound dependency "uid:..."
                set supplier [u2::FindByGuid $models [string range $supplier 4 end]]
            }
            if { $supplier == $root } {
                u2::Delete $dependency
                return
            }
        } 
    }
}


proc BeforeUnload { } {
    set curProject [std::GetActiveProject]
    set model [std::GetModels -kind "U2" -project $curProject]

    set root [u2::FindByGuid $model "@TTDCppImport"]
    if { $root == 0 } {
        return
    }
    
    set resource [u2::GetEntity $root Resource]
	
    RemoveDependency $model $root
    u2::UnloadLibrary $root	
}

