# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
proc SetOptionValue { file key value } {
	set tempFile $file.tmp
	if [catch {
		if [file exists $file] {
			set f [open $file r]
		} else {
			set f [open $file w+]
		} } ] {
		return 0
	}
	if [catch {set tmpf [open $tempFile w]}] {
		return 0
	}
	
	set result ""
	set valueWritten 0
	while {[gets $f line] >= 0} {
  		if [regexp "$key=(.*)" $line] {
			puts $tmpf $key=$value
			set valueWritten 1
		} else {
			puts $tmpf $line
		}
    	}
	if !$valueWritten {
		puts $tmpf $key=$value
	}
	close $f
	close $tmpf
	if [catch {file copy -force $tempFile $file}] {
		set result 0
	} else {
		set result 1
	}
	catch {file delete $tempFile}
	return $result
}

proc GetOptionValue { file key } {
	if [catch {set f [open $file r]}] {
		return ""
	}
	set result ""
	while {[gets $f line] >= 0} {
  		if [regexp "$key=(.*)" $line] {
			regsub "$key=(.*)" $line {\1} result
       			break
		}
    	}
	close $f
	return $result
}
