# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# Only looks at the current level
proc JEE5MyFind {inContainer lookFor} {
	if {$inContainer == 0 } {
		return 0
	}
  if {[u2::IsKindOf $inContainer Session]} {
    set members [u2::GetEntities $inContainer Library]
  } else {
    set members [u2::GetEntities $inContainer OwnedMember]
  }
  
  foreach el $members {
    if {[u2::GetValue $el Name] == $lookFor} {
      return $el
    
    }
  }

  return 0
}

proc GetActiveSession {} {
   set activeProject [std::GetActiveProject]
   return [lindex [std::GetModels -kind U2 -project $activeProject] 0]
}



#####################################################################################
#
# Global varialbles are used to hold these addresses because FindByName is 
# an expensive call. This improves performance of the pop-up menus significantly.
#
#####################################################################################
proc JEE5InitGlobals {} {
  global msg
  global javax onetoone onetomany manytomany manytoone
  global ejbLocal ejbRemote ejbStateful ejbStateless ejbMessageDriven 
  global persEntity persId
  global agileeegenerated
  global session
  
# Replace FindByName with our own custom Find function, because FindByName
# is very slow. Startup time to load the profile improved 100x
# Old calls left in and commented out for future reference if 
# performance improves on FindByName
# Replace MyFindByName by Findby GUID

#  set javax [u2::FindByName $U2 ::javax]
#  set javax [JEE5MyFind $U2 javax]
  
   set session [GetActiveSession]
   set javax [u2::FindByGuid $session "urm0vIDpaACLwThagV1aJP1E"]
   if { $javax == 0 } {
      std::MessageDialog -name $msg(dlgName) -message $msg(ErrorWhileLoadingAddin) -style ok -icon stop
      return 1
   }
   set agileeegenerated [u2::FindByGuid $session @AgileEE@Generated]
    

#  set onetoone [u2::FindByName $javax persistence::OneToOne]
   set pers [JEE5MyFind $javax persistence]
   set onetoone [JEE5MyFind $pers OneToOne]
#  set onetomany [u2::FindByName $javax persistence::OneToMany]
   set onetomany [JEE5MyFind $pers OneToMany]
#  set manytomany [u2::FindByName $javax persistence::ManyToMany]
   set manytomany [JEE5MyFind $pers ManyToMany]
#  set manytoone [u2::FindByName $javax persistence::ManyToOne]
   set manytoone [JEE5MyFind $pers ManyToOne]
#
#  set ejbLocal [u2::FindByName $javax "::ejb::Local"]
   set ejb [JEE5MyFind $javax ejb]
   set ejbLocal [JEE5MyFind $ejb Local]
#  set ejbRemote [u2::FindByName $javax "::ejb::Remote"]
   set ejbRemote [JEE5MyFind $ejb Remote]
#  set ejbStateful [u2::FindByName $javax "::ejb::Stateful"]
   set ejbStateful [JEE5MyFind $ejb Stateful]
#  set ejbStateless [u2::FindByName $javax "::ejb::Stateless"]
   set ejbStateless [JEE5MyFind $ejb Stateless]
#  set ejbMessageDriven [u2::FindByName $javax "::ejb::MessageDriven"]
   set ejbMessageDriven [JEE5MyFind $ejb MessageDriven]
#
#  set persEntity [u2::FindByName $javax "::persistence::Entity"]
  set persEntity [JEE5MyFind $pers Entity]
#  set persId [u2::FindByName $javax "::persistence::Id"]
  set persId [JEE5MyFind $pers Id]
  return 0
 
}
