# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

proc ReportConnectorEnds { elmt } {

  if { [catch { set connectorEnds [u2::GetEntities $elmt ConnectorEnd] } ] } { return };

  if { [llength $connectorEnds] == 0 } { return };#end_if there are no connector ends to report

  foreach connEnd $connectorEnds {

    set cePart [u2::GetEntity $connEnd Part]
    set cePort [u2::GetEntity $connEnd Port]

    set cePartName [GetElementName $cePart]
    set cePortName [GetElementName $cePort]

    html_bullet "$cePartName : $cePortName"

  };#end_foreach connector end

};#end_proc ReportConnectorEnds
