# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

proc ReportConnectors { elmt headingLevel } {

  if { [catch { set connectorList [u2::GetEntities $elmt Connector] } ] } { return };

  if { [llength $connectorList] == 0 } { return };#end_if there are no connectors to report

  html_paragraph ""
  html_heading $headingLevel "" "Connectors"


  foreach connector $connectorList {

    # Create connector report heading
    html_bullet_start

    # Add the connector's name to the heading
    html_print [GetElementName $connector]

    html_bullet_end

    html_list_start
#    ReportProperties $connector 0
    ReportConnectorEnds $connector
    html_list_end

  };#end_foreach connector

};#end_proc ReportConnectors
