# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

proc ReportDefaultValue { elmt } {

  if { [catch { set defaultValue [u2::GetEntity $elmt DefaultValue] } ] } { return };

  if { $defaultValue != 0 } {

    switch [u2::GetMetaClassName $defaultValue] {
      IntegerValue -
      RealValue {
        html_bullet "Default Value: [u2::GetValue $defaultValue ValueString]"
      }
      Ident {
        html_bullet "Default Value: [GetElementName $defaultValue]"
      }
      CharacterValue {
        dbg::Output "\n\n*** CharacterValue ***\n\n"
        html_bullet "Default Value: \'[u2::GetValue $defaultValue Value]\'"
      }
      CharstringValue {
        dbg::Output "\n\n*** CharstringValue ***\n\n"
        html_bullet "Default Value: \"[u2::GetValue $defaultValue Value]\""
      }
      default {
        dbg::Output "Unhandled default value type: [u2::GetMetaClassName $defaultValue]\n";
        return
      }
    };#end_switch on default value type

  };#end_if attribute has default value

};#end_proc ReportDefaultValue
