# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

proc ReportDiagrams { elmt headingLevel } {

  global bIncludeFrames

  set diagramList $elmt

  if { ![u2::IsKindOf $elmt Diagram] } {
    if { [catch { set diagramList [u2::GetEntities $elmt Diagram] } ] } { return }
  };#end_if element is not a diagram

  if { [llength $diagramList] == 0 } { return } ;# end_if no attributes in element to report

  html_paragraph ""
  html_heading $headingLevel "" "Diagrams"


  foreach diagram $diagramList {

    # Diagram shall be saved in EMF file
    set diagramFileName [BuildFileName $diagram]  ;# Set emf file name
    set diagramFilePath [file join [pwd] HTML $diagramFileName.emf] ;# Set emf file path

    # Generate diagram emf file
    u2::GenerateEMF $diagram $diagramFilePath -includeFrame $bIncludeFrames

    # Insert picture in report
    set pictZoom 100  ;# size in Percentage; may be modified by user for custom fit

    html_paragraph_start
    html_image "$diagramFileName.emf" $pictZoom
    html_paragraph_end

  };#end_foreach diagram

};#end_proc ReportDiagrams


proc ReportTextDiagram { txtDiagram } {

  set diagElements [u2::GetEntities $txtDiagram "DiagramElement"]

  foreach diagE $diagElements {

    if { ![u2::IsKindOf $diagE "TextSymbol"] } { continue }

    set textValue [u2::GetValue $diagE "Text"]
    set textValue [CorrectForHTML $textValue]

    # Report Text Diagram content
    html_paragraph ""
    html_pre $textValue
    html_paragraph ""

  };#end_foreach diagram element

};#end_proc ReportTextDiagram
