/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef CODER_REMOVE_PER

#include "er/per/per_content.h"

/*************************************************/

#ifndef CODER_NOUSE_BOOLEAN
static void PEREncodeBOOLEAN(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void PERDecodeBOOLEAN(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
#endif

/*************************************************/

#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
static void PEREncodeOBJECT_IDENTIFIER(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void PERDecodeOBJECT_IDENTIFIER(tCoder* Coder, tASN1TypeInfo* Type, void* val);
#endif

/*************************************************/

#ifndef CODER_NOUSE_NULL
#define PEREncodeNULL(Coder, Type, Val)
#define PERDecodeNULL(Coder, Type, Val) VMSSetNULL(Coder, Val, Type, NULL)
#endif

/*************************************************/

#ifndef CODER_NOUSE_REAL
static void PEREncodeREAL(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void PERDecodeREAL(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
#endif

/*************************************************/

#ifndef CODER_NOUSE_INTEGER
static void PEREncodeINTEGER(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void PERDecodeINTEGER(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
#endif

/*************************************************/

#ifndef CODER_NOUSE_BIT_STRING
static void PEREncodeBIT_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void PERDecodeBIT_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
#endif

/*************************************************/

#ifndef CODER_NOUSE_OCTET_STRING
static void PEREncodeOCTET_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void PERDecodeOCTET_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
#endif

/*************************************************/

#ifndef CODER_NOUSE_CHARACTER_STRING

static void PEREncodeCHARACTER_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void PERDecodeCHARACTER_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val);

/*************************************************/

#define PEREncodeNumericString(Coder, Type, Val) PEREncodeCHARACTER_STRING(Coder, Type, Val)
#define PERDecodeNumericString(Coder, Type, Val) PERDecodeCHARACTER_STRING(Coder, Type, Val)

/*************************************************/

#define PEREncodePrintableString(Coder, Type, Val) PEREncodeCHARACTER_STRING(Coder, Type, Val)
#define PERDecodePrintableString(Coder, Type, Val) PERDecodeCHARACTER_STRING(Coder, Type, Val)

/*************************************************/

#define PEREncodeIA5String(Coder, Type, Val) PEREncodeCHARACTER_STRING(Coder, Type, Val)
#define PERDecodeIA5String(Coder, Type, Val) PERDecodeCHARACTER_STRING(Coder, Type, Val)

/*************************************************/

#define PEREncodeVisibleString(Coder, Type, Val) PEREncodeCHARACTER_STRING(Coder, Type, Val)
#define PERDecodeVisibleString(Coder, Type, Val) PERDecodeCHARACTER_STRING(Coder, Type, Val)

/*************************************************/

#define PEREncodeUTCTime(Coder, Type, Val) PEREncodeCHARACTER_STRING(Coder, Type, Val)
#define PERDecodeUTCTime(Coder, Type, Val) PERDecodeCHARACTER_STRING(Coder, Type, Val)

/*************************************************/

#define PEREncodeGeneralizedTime(Coder, Type, Val) PEREncodeCHARACTER_STRING(Coder, Type, Val)
#define PERDecodeGeneralizedTime(Coder, Type, Val) PERDecodeCHARACTER_STRING(Coder, Type, Val)

#endif /* CODER_NOUSE_CHARACTER_STRING */
/*************************************************/

#ifndef CODER_NOUSE_ENUMERATED
static void PEREncodeENUMERATED(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void PERDecodeENUMERATED(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
#endif

/*************************************************/

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
static void PEREncodeStruct(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void PERDecodeStruct(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tVMSOpenTypeList* List);
#endif

/*************************************************/

#ifndef CODER_NOUSE_SEQUENCE
#define PEREncodeSEQUENCE(Coder, Type, Val) PEREncodeStruct(Coder, Type, Val)
#define PERDecodeSEQUENCE(Coder, Type, Val, List) PERDecodeStruct(Coder, Type, Val, List)
#endif

/*************************************************/

#ifndef CODER_NOUSE_SET
#define PEREncodeSET(Coder, Type, Val) PEREncodeStruct(Coder, Type, Val)
#define PERDecodeSET(Coder, Type, Val, List) PERDecodeStruct(Coder, Type, Val, List)
#endif

/*************************************************/

#ifndef CODER_NOUSE_SEQUENCE_OF
static void PEREncodeSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void PERDecodeSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tVMSOpenTypeList* List);
#endif

/*************************************************/

#ifndef CODER_NOUSE_SET_OF
static void PEREncodeSET_OF(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void PERDecodeSET_OF(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tVMSOpenTypeList* List);
#endif

/*************************************************/

#ifndef CODER_NOUSE_CHOICE
static void PEREncodeCHOICE(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void PERDecodeCHOICE(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tVMSOpenTypeList* List);
#endif

/*************************************************/

#define PEREncodeDEFINED(Coder, Type, Val) PEREncVal(Coder, ((tASN1Defined*)Type)->BaseType, Val)
#define PERDecodeDEFINED(Coder, Type, Val, List) PERDecVal(Coder, ((tASN1Defined*)Type)->BaseType, Val, List)

/*************************************************/

#define PEREncodeTAGGED(Coder, Type, Val) PEREncVal(Coder, ((tASN1Tagged*)Type)->BaseType, Val)
#define PERDecodeTAGGED(Coder, Type, Val, List) PERDecVal(Coder, ((tASN1Tagged*)Type)->BaseType, Val, List)

/*************************************************/

#ifndef CODER_NOUSE_OPEN
#define PEREncodeOPEN_ID(Coder, Type, Val) PEREncVal(Coder, ((tASN1OpenId*)Type)->BaseType, Val)
static void PERDecodeOPEN_ID(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tVMSOpenTypeList* List);
static void PEREncodeOPEN(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
static void PERDecodeOPEN(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tVMSOpenTypeList* List);

static void PERDecodeSkipedValues(tCoder* Coder, tVMSOpenTypeList* List);
#endif

/*************************************************/

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET) || !defined(CODER_NOUSE_OPEN)
static void PERSkipOPENTypeField(tCoder* Coder);
#endif

/*************************************************/
/******************** MAIN ***********************/
/*************************************************/

/**************************************************
 * NAME: PEREncVal
 *       
 *
 */

void
PEREncVal(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncVal\n");
#endif

  switch(Type->TypeClass)
    {
#ifndef CODER_NOUSE_BOOLEAN
    case type_ASN1_BOOLEAN:
      PEREncodeBOOLEAN(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_NULL
    case type_ASN1_NULL:
      PEREncodeNULL(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
    case type_ASN1_OBJECT_IDENTIFIER:
      PEREncodeOBJECT_IDENTIFIER(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_REAL
    case type_ASN1_REAL:
      PEREncodeREAL(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_INTEGER
    case type_ASN1_INTEGER:
      PEREncodeINTEGER(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_BIT_STRING
    case type_ASN1_BIT_STRING:
      PEREncodeBIT_STRING(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_OCTET_STRING
    case type_ASN1_OCTET_STRING:
      PEREncodeOCTET_STRING(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_CHARACTER_STRING
    case type_ASN1_NumericString:
      PEREncodeNumericString(Coder, Type, Val);
      break;
    case type_ASN1_PrintableString:
      PEREncodePrintableString(Coder, Type, Val);
      break;
    case type_ASN1_IA5String:
      PEREncodeIA5String(Coder, Type, Val);
      break;
    case type_ASN1_VisibleString:
      PEREncodeVisibleString(Coder, Type, Val);
      break;
    case type_ASN1_UTCTime:
      PEREncodeUTCTime(Coder, Type, Val);
      break;
    case type_ASN1_GeneralizedTime:
      PEREncodeGeneralizedTime(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_ENUMERATED
    case type_ASN1_ENUMERATED:
      PEREncodeENUMERATED(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_SEQUENCE
    case type_ASN1_SEQUENCE:
      PEREncodeSEQUENCE(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_SET
    case type_ASN1_SET:
      PEREncodeSET(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_SEQUENCE_OF
    case type_ASN1_SEQUENCE_OF:
      PEREncodeSEQUENCE_OF(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_SET_OF
    case type_ASN1_SET_OF:
      PEREncodeSET_OF(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_CHOICE
    case type_ASN1_CHOICE:
      PEREncodeCHOICE(Coder, Type, Val);
      break;
#endif
    case type_ASN1_DEFINED:
      PEREncodeDEFINED(Coder, Type, Val);
      break;
    case type_ASN1_TAGGED:
      PEREncodeTAGGED(Coder, Type, Val);
      break;
#ifndef CODER_NOUSE_OPEN
    case type_ASN1_OPEN_ID:
      PEREncodeOPEN_ID(Coder, Type, Val);
      break;
    case type_ASN1_OPEN:
      PEREncodeOPEN(Coder, Type, Val);
      break;
#endif
    default:
      INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_UnsupportedType, NO_ARGS);
    }
}

/**************************************************
 * NAME: PERDecVal
 *       
 *
 */

void
PERDecVal(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tVMSOpenTypeList* List)
{

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecVal\n");
#endif

  switch(Type->TypeClass)
    {
#ifndef CODER_NOUSE_BOOLEAN
    case type_ASN1_BOOLEAN:
      PERDecodeBOOLEAN(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_NULL
    case type_ASN1_NULL:
      PERDecodeNULL(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
    case type_ASN1_OBJECT_IDENTIFIER:
      PERDecodeOBJECT_IDENTIFIER(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_REAL
    case type_ASN1_REAL:
      PERDecodeREAL(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_INTEGER
    case type_ASN1_INTEGER:
      PERDecodeINTEGER(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_BIT_STRING
    case type_ASN1_BIT_STRING:
      PERDecodeBIT_STRING(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_OCTET_STRING
    case type_ASN1_OCTET_STRING:
      PERDecodeOCTET_STRING(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_CHARACTER_STRING
    case type_ASN1_NumericString:
      PERDecodeNumericString(Coder, Type, Val);
      break;
    case type_ASN1_PrintableString:
      PERDecodePrintableString(Coder, Type, Val);
      break;
    case type_ASN1_IA5String:
      PERDecodeIA5String(Coder, Type, Val);
      break;
    case type_ASN1_VisibleString:
      PERDecodeVisibleString(Coder, Type, Val);
      break;
    case type_ASN1_UTCTime:
      PERDecodeUTCTime(Coder, Type, Val);
      break;
    case type_ASN1_GeneralizedTime:
      PERDecodeGeneralizedTime(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_ENUMERATED
    case type_ASN1_ENUMERATED:
      PERDecodeENUMERATED(Coder, Type, Val);
      break;
#endif
#ifndef CODER_NOUSE_SEQUENCE
    case type_ASN1_SEQUENCE:
      VMSInitSEQUENCE(Coder, Val, Type);
      PERDecodeSEQUENCE(Coder, Type, Val, List);
      break;
#endif
#ifndef CODER_NOUSE_SET
    case type_ASN1_SET:
      VMSInitSET(Coder, Val, Type);
      PERDecodeSET(Coder, Type, Val, List);
      break;
#endif
#ifndef CODER_NOUSE_SEQUENCE_OF
    case type_ASN1_SEQUENCE_OF:
      PERDecodeSEQUENCE_OF(Coder, Type, Val, List);
      break;
#endif
#ifndef CODER_NOUSE_SET_OF
    case type_ASN1_SET_OF:
      PERDecodeSET_OF(Coder, Type, Val, List);
      break;
#endif
#ifndef CODER_NOUSE_CHOICE
    case type_ASN1_CHOICE:
      PERDecodeCHOICE(Coder, Type, Val, List);
      break;
#endif
    case type_ASN1_DEFINED:
      PERDecodeDEFINED(Coder, Type, Val, List);
      break;
    case type_ASN1_TAGGED:
      PERDecodeTAGGED(Coder, Type, Val, List);
      break;
#ifndef CODER_NOUSE_OPEN
    case type_ASN1_OPEN_ID:
      PERDecodeOPEN_ID(Coder, Type, Val, List);
      break;
    case type_ASN1_OPEN:
      PERDecodeOPEN(Coder, Type, Val, List);
      break;
#endif
    default:
      INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_UnsupportedType, NO_ARGS);
    }
}

/*************************************************/
/********** SHARED INTEGERs FUNCTIONS ************/
/*************************************************/

#define BitsToBytes(Bits) (unsigned char)((Bits >> 3) + ((Bits & 0x7) ? 1 : 0))

/*************************************************/

#define PERGetNumOfBits(InVal, OutNum) \
for (OutNum = 0; InVal > 0; OutNum++, InVal >>= 1)

/*************************************************/

#define PEREncodeNonNegativeBinaryINTEGER(Coder, InVal, NumOfBits) \
  PERPutBits(Coder, InVal, NumOfBits)

#define PERDecodeNonNegativeBinaryINTEGER(Coder, NumOfBits, OutVal) \
  OutVal = PERGetBits(Coder, NumOfBits)

/**************************************************
 * NAME: PEREncodeConstrainedWholeNumber
 *       
 *
 */

static void
PEREncodeConstrainedWholeNumber(tCoder* Coder, long LBound, long UBound, tVMSInteger vInt)
{
  unsigned long MaxEncNumber = UBound - LBound;
  unsigned long EncNumber = vInt - LBound;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeConstrainedWholeNumber\n");
#endif

  if (Coder->ER.Rule & er_Aligned)
    {
      unsigned long Range = MaxEncNumber + 1;
      
      if (Range == 1)
        {
          /* Nothing */
        }
      else
      if (Range <= 0xFF)
        {
          unsigned char NumOfBits;

          PERGetNumOfBits(MaxEncNumber, NumOfBits);
          PEREncodeNonNegativeBinaryINTEGER(Coder, EncNumber, NumOfBits);
        }
      else
      if (Range == 0x100)
        {
          PERAlign(Coder);

          if (Coder->ER.DataCurr == Coder->ER.MemEnd)
            PERAppendBufMemory(Coder, 1);
          
          *(Coder->ER.DataCurr) = (unsigned char)EncNumber;
          Coder->ER.DataCurr++;
        }
      else
      if (Range <= 0x10000)
        {
          PERAlign(Coder);

          if (Coder->ER.MemEnd - Coder->ER.DataCurr < 2)
            PERAppendBufMemory(Coder, 2 - (Coder->ER.MemEnd - Coder->ER.DataCurr));

          *(Coder->ER.DataCurr) = (unsigned char)(EncNumber >> 8);
          Coder->ER.DataCurr++;
          *(Coder->ER.DataCurr) = (unsigned char)EncNumber;
          Coder->ER.DataCurr++;
        }
      else
        {
          unsigned char NumOfBits, NumOfBytes, NumOfBitsMaxEncNumber;

          PERGetNumOfBits(MaxEncNumber, NumOfBits);            /* MaxEncNumber == 0 */
          NumOfBytes = BitsToBytes(NumOfBits);  
          PERGetNumOfBits(NumOfBytes, NumOfBitsMaxEncNumber);  /* NumOfBytes == 0 */

          PERGetNumOfBits(EncNumber, NumOfBits);               /* EncNumber == 0 */
          if (NumOfBits != 0)
            NumOfBytes = BitsToBytes(NumOfBits);
          else
            NumOfBytes = 1;

          PEREncodeNonNegativeBinaryINTEGER(Coder, (tVMSULong)(NumOfBytes - 1), NumOfBitsMaxEncNumber);
          PERAlign(Coder);
          PEREncodeNonNegativeBinaryINTEGER(Coder, vInt - LBound, (unsigned char)(NumOfBytes << 3));
        }      
    }
  else
    {
      unsigned char NumOfBits;

      PERGetNumOfBits(MaxEncNumber, NumOfBits);
      PEREncodeNonNegativeBinaryINTEGER(Coder, EncNumber, NumOfBits);
    }
}

/**************************************************
 * NAME: PERDecodeConstrainedWholeNumber
 *       
 *
 */

static void
PERDecodeConstrainedWholeNumber(tCoder* Coder, long LBound, long UBound, tVMSInteger* vInt)
{
  unsigned long MaxEncNumber = UBound - LBound;
  tVMSULong EncNumber = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeConstrainedWholeNumber\n");
#endif

  if (Coder->ER.Rule & er_Aligned)
    {
      unsigned long Range = MaxEncNumber + 1;
      if (Range == 1)
        {
          /* NOTHING */
        }
      else
      if (Range <= 0xFF)
        {
          unsigned char NumOfBits;
          
          PERGetNumOfBits(MaxEncNumber, NumOfBits);
          PERDecodeNonNegativeBinaryINTEGER(Coder, NumOfBits, EncNumber);
        }
      else
      if (Range <= 0x100)
        {
          PERAlign(Coder);
          PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 1, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
          EncNumber = *(Coder->ER.DataCurr); 
          Coder->ER.DataCurr++;
        }
      else
      if (Range <= 0x10000)
        {
          PERAlign(Coder);
          PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 2, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
          EncNumber = (*(Coder->ER.DataCurr) << 8);
          Coder->ER.DataCurr++;
          EncNumber |= *(Coder->ER.DataCurr);
          Coder->ER.DataCurr++;
        }
      else
        {
          unsigned char NumOfBits;
          unsigned char NumOfBytes;
          unsigned char NumOfBitsMaxEncNumber;

          PERGetNumOfBits(MaxEncNumber, NumOfBits);          /* MaxEncNumber == 0 */
          NumOfBytes = (unsigned char)BitsToBytes(NumOfBits);
          PERGetNumOfBits(NumOfBytes, NumOfBitsMaxEncNumber);  /* NumOfBytes == 0 */

          PERDecodeNonNegativeBinaryINTEGER(Coder, NumOfBitsMaxEncNumber, EncNumber);
          PERAlign(Coder);
          PERDecodeNonNegativeBinaryINTEGER(Coder, (unsigned char)((EncNumber + 1) << 3), EncNumber);
        }
    }
  else
    {
      unsigned char NumOfBits;
      
      PERGetNumOfBits(MaxEncNumber, NumOfBits);
      PERDecodeNonNegativeBinaryINTEGER(Coder, NumOfBits, EncNumber);
    }

  *vInt = LBound + EncNumber;
}



#ifndef CODER_NOUSE_BOOLEAN
/*************************************************/
/****************** BOOLEAN **********************/
/*************************************************/

/**************************************************
 * NAME: PEREncodeBOOLEAN
 *       
 *
 */

static void
PEREncodeBOOLEAN(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tVMSBoolean vBool;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeBOOLEAN\n");
#endif 

  VMSGetBOOLEAN(Coder, Val, Type, vBool);
  PERPutBit(Coder, (unsigned char)(vBool > 0 ? 1 : 0));
}

/**************************************************
 * NAME: PERDecodeBOOLEAN
 *       
 *
 */

static void
PERDecodeBOOLEAN(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tVMSBoolean vBool;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeBOOLEAN\n");
#endif 

  vBool = PERGetBit(Coder);
  VMSSetBOOLEAN(Coder, Val, Type, vBool);
}
#endif


#ifndef CODER_NOUSE_OBJECT_IDENTIFIER
/*************************************************/
/************* OBJECT IDENTIFIER *****************/
/*************************************************/

/**************************************************
 * NAME: PEREncodeOBJECT_IDENTIFIERContent
 *       
 *
 */

static void
PEREncodeOBJECT_IDENTIFIERContent(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tVMSULong NumOfComp;               /* Number of components */
  tVMSObjId_Component CurrComp = 0;  /* Current component */
  tVMSULong SubIdent;                /* Subidentifier */

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeOBJECT_IDENTIFIER\n");
#endif                                                                                  

  VMSGetSizeOBJECT_IDENTIFIER(Coder, Val, Type, NumOfComp);
  VMSGetComponentOBJECT_IDENTIFIER(Coder, Val, Type, 0, CurrComp); /* Indexes: 0,1, ... */
  SubIdent = CurrComp * 40;
  VMSGetComponentOBJECT_IDENTIFIER(Coder, Val, Type, 1, CurrComp); /* Indexes: 0,1, ... */
  SubIdent += CurrComp;
  
  if (SubIdent < 0x80)
    PERPutByte(Coder, (unsigned char)SubIdent);
  else
    {
      tVMSULong SubIdentCpy;
      tVMSULong Len;
      
      for (SubIdentCpy = (SubIdent >> 7), Len = 1; SubIdentCpy > 0; SubIdentCpy >>= 7, Len++);

      Len = (Len - 1) * 7;
      
      while (Len > 0)
        {
          PERPutByte(Coder, (unsigned char)(0x80 | (SubIdent >> Len)));
          Len -= 7;
        }
      
      PERPutByte(Coder, (unsigned char)(SubIdent & 0x7f));
    }
  
  CurrComp = 2; /* Now CurrComp is index */
  while (CurrComp < NumOfComp)
    {
      VMSGetComponentOBJECT_IDENTIFIER(Coder, Val, Type, CurrComp, SubIdent);
      
      if (SubIdent < 0x80)
        PERPutByte(Coder, (unsigned char)SubIdent);
      else
        {
          tVMSULong SubIdentCpy;
          tVMSULong Len;
          
          for (SubIdentCpy = (SubIdent >> 7), Len = 1; SubIdentCpy > 0; SubIdentCpy >>= 7, Len++);
          
          Len = (Len - 1) * 7;
          
          while (Len > 0)
            {
              PERPutByte(Coder, (unsigned char)(0x80 | (SubIdent >> Len)));
              Len -= 7;
            }
          
          PERPutByte(Coder, (unsigned char)(SubIdent & 0x7f));
        }
      CurrComp++;
    }
}

/**************************************************
 * NAME: PERDecodeOBJECT_IDENTIFIERComps
 *       
 *
 */

static void
PERDecodeOBJECT_IDENTIFIERComps(tCoder* Coder, tASN1TypeInfo* Type, tVMSULong Length, void* Val)
{
  unsigned int Lim;
  tVMSULong CurrSubId;
  tVMSULong SubIdent;
  
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeOBJECT_IDENTIFIERComps\n");
#endif                                                                                  

  Lim = UINT_MAX;
  CurrSubId = PERGetByte(Coder);
  SubIdent = (CurrSubId & 0x7F);
  
  Length--;
  while ((CurrSubId & 0x80) && (Lim > 0))
    {
      SubIdent <<= 7;
      CurrSubId = PERGetByte(Coder);
      SubIdent |= (CurrSubId & 0x7F);
      Lim >>= 7;
      Length--;
    }
  
  CurrSubId = SubIdent / 40;
  VMSSetComponentOBJECT_IDENTIFIER(Coder, Val, Type, CurrSubId);
  CurrSubId = SubIdent - CurrSubId * 40;
  VMSSetComponentOBJECT_IDENTIFIER(Coder, Val, Type, CurrSubId);
  
  while (Length > 0)
    {
      Lim = UINT_MAX;
      CurrSubId = PERGetByte(Coder);
      SubIdent = (CurrSubId & 0x7f);
      Length--;
      while ((CurrSubId & 0x80) && (Lim > 0))
        {
          SubIdent <<= 7;
          CurrSubId = PERGetByte(Coder);
          SubIdent |= (CurrSubId & 0x7f);
          Lim >>= 7;
          Length--;
        }
      
      if (Lim == 0)
        DECODING_ERROR_HANDLER(Coder, return, ec_DEC_TooBigSubIdent, NO_ARGS);
      
      VMSSetComponentOBJECT_IDENTIFIER(Coder, Val, Type, SubIdent);
    }
}

/**************************************************
 * NAME: PEREncodeOBJECT_IDENTIFIER
 *       
 *
 */

static void
PEREncodeOBJECT_IDENTIFIER(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tVMSULong StartPos;
  tVMSULong Length;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeOBJECT_IDENTIFIER\n");
#endif                                                                                  

  if (Coder->ER.Rule & er_Aligned)
    { PERAlign(Coder); }

  StartPos = Coder->ER.DataCurr - Coder->ER.DataEnd;

  PERSkipBytes(Coder, 1);

  PEREncodeOBJECT_IDENTIFIERContent(Coder, Type, Val);
  Length = (Coder->ER.DataCurr - Coder->ER.DataEnd) - (StartPos + 1);

  if (Length <= 0x7f)
    {
      unsigned char* CurrByte = Coder->ER.DataEnd + StartPos;

      if (Coder->ER.BitCurr != 7)
        {
          *CurrByte |= (unsigned char)(Length >> (7 - Coder->ER.BitCurr));
          CurrByte++;
          *CurrByte |= (unsigned char)(Length << (Coder->ER.BitCurr + 1));
        }
      else
        *CurrByte = (unsigned char)Length;
    }
  else
    {
      if (Coder->ER.BitCurr == 7)
        PEROctetsFragmentation(Coder, Length);
      else
        PEROctetsFragmentationWithOffset(Coder, Length);
    }
}

/**************************************************
 * NAME: PERDecodeOBJECT_IDENTIFIER
 *       
 *
 */

static void
PERDecodeOBJECT_IDENTIFIER(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  unsigned char Byte;
  tVMSULong Length;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeOBJECT_IDENTIFIER\n");
#endif

  VMSInitOBJECT_IDENTIFIER(Coder, Val, Type);

  if (Coder->ER.Rule & er_Aligned)
    PERAlign(Coder);

  Byte = PERGetByte(Coder);

  if (Byte >= 0xC1)
    {
      Coder->ER.DataCurr--;
      if (Coder->ER.BitCurr != 7)
        {
          Length = PEROctetsDefragmentationWithOffset(Coder);
          PERDecodeOBJECT_IDENTIFIERComps(Coder, Type, Length, Val);
          PEROctetsFragmentationWithOffset(Coder, Length);
        }
      else
        {
          Length = PEROctetsDefragmentation(Coder);
          PERDecodeOBJECT_IDENTIFIERComps(Coder, Type, Length, Val);
          PEROctetsFragmentation(Coder, Length);
        }
    }
  else
  if((Byte & 0xC0) == 0x80)
    {
      Length = (((Byte & 0x7F) << 8) | PERGetByte(Coder));
      PERDecodeOBJECT_IDENTIFIERComps(Coder, Type, Length, Val);
    }
  else
  if((Byte & 0x80) == 0x00)
    {
      Length = (Byte & 0x7F);
      PERDecodeOBJECT_IDENTIFIERComps(Coder, Type, Length, Val);
    }
  else
    {
      DECODING_ERROR_HANDLER(Coder, return, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
    }
}
#endif /* CODER_NOUSE_OBJECT_IDENTIFIER */


#ifndef CODER_NOUSE_REAL
/*************************************************/
/******************** REAL ***********************/
/*************************************************/

/**************************************************
 * NAME: PEREncodeREAL
 *       
 *
 */

static void
PEREncodeREAL(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tVMSReal vReal;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeREAL\n");
#endif

  VMSGetREAL(Coder, Val, Type, vReal);

  if (Coder->ER.Rule & er_Aligned)
    PERAlign(Coder);

  if (vReal.Kind == rk_Zero)
    PERPutByte(Coder, 0);
  else
  if (vReal.Kind == rk_MINUS_INFINITY)
    PERPutBits(Coder, 0x141, 16);
  else
  if (vReal.Kind == rk_PLUS_INFINITY)
    PERPutBits(Coder, 0x140, 16);
  else
    {
      tVMSReal_Mantissa Mantissa = vReal.Mantissa;
      tVMSInteger TmpVal;
      unsigned char FirstOctet = 0, TmpLen, ExpLen;

      if (Mantissa < 0)
        {
          FirstOctet |= 0xC0;
          Mantissa = -Mantissa;
        }
      else
        FirstOctet |= 0x80;

      switch (vReal.Base)
        {
        case 2:
          break;
        case 8:
          FirstOctet |= 0x10;
          break;
        case 16:
          FirstOctet |= 0x20;
          break;
        case 10:
        default:
          VALUE_ERROR_HANDLER(Coder, return, ec_VAL_IllegalRealBase, NO_ARGS);
        }
      
      /* SFACTOR */
      TmpLen = (unsigned char)((Mantissa & 0x1) ? 0 : ((Mantissa >> 1) & 0x1) ? 1 : ((Mantissa >> 2) & 0x1) ? 2 : 3);
      Mantissa >>= TmpLen;

      switch (TmpLen)
        {
        case 1:
          FirstOctet |= 0x04;
          break;
        case 2:
          FirstOctet |= 0x08;
          break;
        case 3:
          FirstOctet |= 0x0C;
          break;
        default:
          break;
        }

      PERGetLengthValueOfInteger(vReal.Exponent, &ExpLen);
      if (vReal.Exponent < 0)
        vReal.Exponent &= (0xFFFFFFFF >> (32 - (ExpLen << 3)));

      TmpLen = 0;
      switch(ExpLen)
        {
        case 1:
          break;
        case 2:
          FirstOctet |= 0x01;
          break;
        case 3:
          FirstOctet |= 0x02;
          break;
        default:
          FirstOctet |= 0x03;
          TmpLen = 1;
          break;
        }

      for (TmpLen = (unsigned char)(TmpLen + ExpLen + 1), TmpVal = Mantissa; TmpVal > 0; TmpVal >>= 8, TmpLen++);

      if (ExpLen > 3)
        {
          PERPutBits(Coder, (unsigned long)((TmpLen << 16) | (FirstOctet << 8) | ExpLen), 24);
          TmpLen -= (unsigned char)2;
        }
      else
        {
          PERPutBits(Coder, (unsigned long)((TmpLen << 8) | FirstOctet), 16);
          TmpLen--;
        }

        PERPutBits(Coder, vReal.Exponent, (unsigned char)(ExpLen << 3));
        TmpLen = (unsigned char)(TmpLen - ExpLen);

        PERPutBits(Coder, Mantissa, (unsigned char)(TmpLen << 3));
    }    
}

/**************************************************
 * NAME: PERDecodeREAL
 *       
 *
 */
static void
PERDecodeREAL(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tVMSReal vReal;
  unsigned char Byte;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeREAL\n");
#endif

  if (Coder->ER.Rule & er_Aligned)
    PERAlign(Coder);

  Byte = PERGetByte(Coder);

  if (Byte == 0)
    vReal.Kind = rk_Zero;
  else
  if (Byte == 1)
    {
      Byte = PERGetByte(Coder);
      if (Byte == 0x40)
        vReal.Kind = rk_PLUS_INFINITY;
      else
      if (Byte == 0x41)
        vReal.Kind = rk_MINUS_INFINITY;
      else
        {
          DECODING_ERROR_HANDLER(Coder, return, ec_DEC_WrongRealPrefix, NO_ARGS);
        }      
    }
  else
    {
      tVMSReal_Exponent Exponent;
      tVMSReal_Mantissa Mantissa;
      tVMSULong ExpLen, Length;
      unsigned char FirstOctet;

      Length = Byte;

      FirstOctet = PERGetByte(Coder);
      Length--;

      if (FirstOctet & 0x80)
        {         
          ExpLen = (FirstOctet & 0x03) + 1;
          if (ExpLen == 4)
            {
              ExpLen = PERGetByte(Coder);
              Length--;
            }

          Exponent = PERGetBits(Coder, (unsigned char)(ExpLen << 3));
          if ((ExpLen != sizeof(long)) && (Exponent & (0x80 << ((ExpLen - 1) << 3))))
            /*            Exponent |= (~0U << (ExpLen << 3));*/
            Exponent |= (0xFFFFFFFF << (ExpLen << 3));
          
          Length -= ExpLen;

          Mantissa = PERGetBits(Coder, (unsigned char)(Length << 3));
          
          Mantissa <<= ((FirstOctet & 0x0C) >> 2);
          
          switch (FirstOctet & 0x30)
            {
            case 0x00:
              vReal.Base = 2;
              break;
            case 0x10:
              vReal.Base = 8;
              break;
            case 0x20:
              vReal.Base = 16;
              break;
            default:
              DECODING_ERROR_HANDLER(Coder, return, ec_DEC_UnsupportedRealBase, NO_ARGS);
              break;
            }
          
          if (FirstOctet & 0x40) vReal.Mantissa = -Mantissa;
          else vReal.Mantissa = Mantissa;
          
          vReal.Exponent = Exponent;
          vReal.Kind = rk_Value;
        }
      else
        {
          DECODING_ERROR_HANDLER(Coder, return, ec_DEC_UnsupportedRealDecimalEncoding, NO_ARGS);
        }        
    }

  VMSSetREAL(Coder, Val, Type, vReal);
}
#endif /* CODER_NOUSE_REAL */

#if !defined(CODER_NOUSE_INTEGER) || !defined(CODER_NOUSE_ENUMERATED) || !defined(CODER_NOUSE_CHOICE)
/**************************************************
 * NAME: PEREncodeSemiConstrainedWholeNumber
 *       
 *
 */

static void
PEREncodeSemiConstrainedWholeNumber(tCoder* Coder, long LBound, tVMSInteger vInt)
{
  tVMSULong EncNumber = vInt - LBound;
  unsigned char Length;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeSemiConstrainedWholeNumber\n");
#endif

  if (Coder->ER.Rule & er_Aligned)
    { PERAlign(Coder); }

  if (EncNumber > 0)
    {
      for (Length = 0; EncNumber > 0; EncNumber >>= 8, Length++);
      EncNumber = vInt - LBound;

      PERPutByte(Coder, Length);
      PERPutBits(Coder, EncNumber, (unsigned char)(Length << 3));
    }
  else
    PERPutBits(Coder, 0x100, 16);
}

/**************************************************
 * NAME: PERDecodeSemiConstrainedWholeNumber
 *       
 *
 */

static void
PERDecodeSemiConstrainedWholeNumber(tCoder* Coder, long LBound, tVMSInteger* vInt)
{
  unsigned char NumOfOctets;
  tVMSULong EncNumber;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeSemiConstrainedWholeNumber\n");
#endif

  /* Decode length */
  if (Coder->ER.Rule & er_Aligned)
    { PERAlign(Coder); }

  NumOfOctets = PERGetByte(Coder);
  EncNumber = PERGetBits(Coder, (unsigned char)(NumOfOctets << 3));

  *vInt = LBound + EncNumber;
}
#endif /* !defined(CODER_NOUSE_INTEGER) || !defined(CODER_NOUSE_ENUMERATED) || !defined(CODER_NOUSE_CHOICE) */

#ifndef CODER_NOUSE_INTEGER
/*************************************************/
/****************** INTEGER **********************/
/*************************************************/

/**************************************************
 * NAME: PEREncodeUnconstrainedWholeNumber
 *       
 *
 */

static void
PEREncodeUnconstrainedWholeNumber(tCoder* Coder, tVMSInteger vInt)
{
  register unsigned long mask = (0x7f80 << ((sizeof(unsigned long) - 2) << 3));
  register unsigned char i = sizeof(unsigned long);

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeUnconstrainedWholeNumber\n");
#endif

  if (vInt < 0)
    {
      for (; (i > 1) && ((vInt & mask) == mask); mask >>= 8, i--);
      vInt &= (0xFFFFFFFF >> (32 - (i << 3)));
    }
  else
    for (; (i > 1) && ((vInt & mask) == 0); mask >>= 8, i--);

  PERPutByte(Coder, i);
  PERPutBits(Coder, vInt, (unsigned char)(i << 3));
}

/**************************************************
 * NAME: PERDecodeUnconstrainedWholeNumber
 *       
 *
 */

static void
PERDecodeUnconstrainedWholeNumber(tCoder* Coder, tVMSInteger* vInt)
{
  unsigned char i = PERGetByte(Coder);
  
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeUnconstrainedWholeNumber\n");
#endif

  *vInt = (tVMSInteger)PERGetBits(Coder, (unsigned char)(i << 3));
  if ((i != sizeof(long)) && (*vInt & (0x80 << ((i - 1) << 3))))
    /*    *vInt |= (~0U << (i << 3));*/
    *vInt |= (0xFFFFFFFF << (i << 3));
}


/*************************************************/

/* Low bound of constraint */
#define PERIntegerLBound(iType) (((tASN1Integer*)iType)->ConstraintMask & 0x10)
/* Up bound of constraint */
#define PERIntegerUBound(iType) (((tASN1Integer*)iType)->ConstraintMask & 0x01)
/* Extension marker */
#define PERIntegerExtMarker(iType) ((tASN1Integer*)iType)->IntegerConstraint.ExtMarker

/**************************************************
 * NAME: PEREncodeINTEGER
 *       
 *
 */

static void
PEREncodeINTEGER(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tVMSInteger vInt;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeINTEGER\n");
#endif

  VMSGetINTEGER(Coder, Val, Type, vInt);

  VALUE_ERROR_HANDLER_EXP((Coder->EMS.ErrorCode =
                          CUCFCheckINTEGER(Coder, Type, &vInt)) != ec_SUCCESS,
                          Coder,
                          return,
                          Coder->EMS.ErrorCode,
                          ERR_ARG("INTEGER"));

  if (PERIntegerExtMarker(Type) == em_Present)
    {
      if (((PERIntegerLBound(Type)) && (vInt < ((tASN1Integer*)Type)->IntegerConstraint.pLBound)) ||
          ((PERIntegerUBound(Type)) && (vInt > ((tASN1Integer*)Type)->IntegerConstraint.pUBound)))
        {
          PERPutBit(Coder, 1);

          if (Coder->ER.Rule & er_Aligned)
            { PERAlign(Coder); }

          PEREncodeUnconstrainedWholeNumber(Coder, vInt);
          return;
        }
      else
        PERPutBit(Coder, 0);
    }

  if (PERIntegerLBound(Type))
    {
      if (PERIntegerUBound(Type))
        PEREncodeConstrainedWholeNumber(Coder, ((tASN1Integer*)Type)->IntegerConstraint.pLBound,
                                        ((tASN1Integer*)Type)->IntegerConstraint.pUBound, vInt);
      else
        PEREncodeSemiConstrainedWholeNumber(Coder, ((tASN1Integer*)Type)->IntegerConstraint.pLBound, vInt);
    }
  else
    {
      if (Coder->ER.Rule & er_Aligned)
        { PERAlign(Coder); }

      PEREncodeUnconstrainedWholeNumber(Coder, vInt);
    }
}

/**************************************************
 * NAME: PERDecodeINTEGER
 *       
 *
 */

static void
PERDecodeINTEGER(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tVMSInteger vInt;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeINTEGER\n");
#endif

  if ((PERIntegerExtMarker(Type) == em_Present) && (PERGetBit(Coder) == 1))
    {
      if (Coder->ER.Rule & er_Aligned)
        { PERAlign(Coder); }

      PERDecodeUnconstrainedWholeNumber(Coder, &vInt);
    }
  else
  if (PERIntegerLBound(Type))
    {
      if (PERIntegerUBound(Type))
        PERDecodeConstrainedWholeNumber(Coder, ((tASN1Integer*)Type)->IntegerConstraint.pLBound,
                                        ((tASN1Integer*)Type)->IntegerConstraint.pUBound, &vInt);
      else
        PERDecodeSemiConstrainedWholeNumber(Coder, ((tASN1Integer*)Type)->IntegerConstraint.pLBound, &vInt);
    }
  else
    {
      if (Coder->ER.Rule & er_Aligned)
        { PERAlign(Coder); }

      PERDecodeUnconstrainedWholeNumber(Coder, &vInt);
    }

  VMSSetINTEGER(Coder, Val, Type, vInt);

  VALUE_ERROR_HANDLER_EXP((Coder->EMS.ErrorCode =
                          CUCFCheckINTEGER(Coder, Type, &vInt)) != ec_SUCCESS,
                          Coder,
                          return,
                          Coder->EMS.ErrorCode,
                          ERR_ARG("INTEGER"));
}

#endif /* CODER_NOUSE_INTEGER */

#ifndef CODER_NOUSE_BIT_STRING
/*************************************************/
/***************** BIT STRING ********************/
/*************************************************/

/**************************************************
 * NAME: PEREncodePrimBIT_STRING
 *       
 *
 */

static void
PEREncodePrimBIT_STRING(tCoder* Coder, tVMSULong Length, tPERConstructedInfo* Info)
{
  tVMSULong NumOfBytes = (Length >> 3);
  unsigned char NumOfBits = (unsigned char)(Length & 0x7);
  unsigned char* CurrStrVal = (unsigned char*)(Info->Value);

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodePrimBIT_STRING\n");
#endif

  if (NumOfBytes > 0)
    {
      if (Coder->ER.BitCurr != 7)
        {
          tVMSULong i;
          unsigned char Byte;

          if (Coder->ER.DataCurr + NumOfBytes + 1 > Coder->ER.MemEnd)
            PERAppendBufMemory(Coder, NumOfBytes + 1 - (Coder->ER.MemEnd - Coder->ER.DataCurr));

          VMSGetOctetBIT_STRING(Coder, CurrStrVal, (Coder->ER.BitCurr + 1), Byte);
          *(Coder->ER.DataCurr) |= (unsigned char)(Byte >> (7 - Coder->ER.BitCurr));
          Coder->ER.DataCurr++;

          for (i = 0; i < NumOfBytes - 1; i++, Coder->ER.DataCurr++)
            VMSGetOctetBIT_STRING(Coder, CurrStrVal, 8, *(Coder->ER.DataCurr));

          VMSGetOctetBIT_STRING(Coder, CurrStrVal, (7 - Coder->ER.BitCurr), *(Coder->ER.DataCurr));          
        }
      else
        {
          tVMSULong i;

          if (Coder->ER.DataCurr + NumOfBytes > Coder->ER.MemEnd)
            PERAppendBufMemory(Coder, NumOfBytes - (Coder->ER.MemEnd - Coder->ER.DataCurr));

          for (i = 0; i < NumOfBytes; i++, Coder->ER.DataCurr++)
            VMSGetOctetBIT_STRING(Coder, CurrStrVal, 8, *(Coder->ER.DataCurr));
        }

      Info->Value = (unsigned char*)(Info->Value) + Length;
      Info->Length -= Length;
    }

  if (NumOfBits > 0)
    {
      tVMSULong RemBits;
      VMSGetOctetBIT_STRING(Coder, CurrStrVal, NumOfBits, RemBits);
      RemBits >>= (8 - NumOfBits);
      PERPutBits(Coder, RemBits, NumOfBits);
    }
}


/**************************************************
 * NAME: PERDecodePrimBIT_STRING
 *       
 *
 */

static void
PERDecodePrimBIT_STRING(tCoder* Coder, tVMSULong Length, tPERConstructedInfo* Info)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodePrimBIT_STRING\n");
#endif

  if (Length > 0)
    {
      unsigned char* CurrStrVal;
      tVMSULong NOB = Length >> 3;
      unsigned char RB = (unsigned char)(Length & 0x7);

      VMSAllocBIT_STRING(Coder, (*Info), CurrStrVal, Length);

      if (NOB > 0)
        {
          if (Coder->ER.BitCurr != 7)
            {
              unsigned char Byte = (unsigned char)(*(Coder->ER.DataCurr) << (7 - Coder->ER.BitCurr));
              VMSPutOctetBIT_STRING(Coder, CurrStrVal, Byte, Coder->ER.BitCurr + 1);
              Coder->ER.DataCurr++;

              for (; NOB > 1; NOB--, Coder->ER.DataCurr++)
                VMSPutOctetBIT_STRING(Coder, CurrStrVal, *(Coder->ER.DataCurr), 8);

              VMSPutOctetBIT_STRING(Coder, CurrStrVal, *(Coder->ER.DataCurr), (7 - Coder->ER.BitCurr));
            }
          else
            {
              for (; NOB > 0; NOB--, Coder->ER.DataCurr++)
                VMSPutOctetBIT_STRING(Coder, CurrStrVal, *(Coder->ER.DataCurr), 8);
            }
        }

      if (RB > 0)
        {
          unsigned char RemBits = (unsigned char)(PERGetBits(Coder, RB) << (8 - RB));
          VMSPutOctetBIT_STRING(Coder, CurrStrVal, RemBits, RB);
        }
    }
}

/**************************************************
 * NAME: PEREncodeConsBIT_STRING
 */

#define PEREncodeConsBIT_STRING(Coder, Info) PERConstructedEncode(Coder, Info)

/**************************************************
 * NAME: PERDecodeConsBIT_STRING
 */

#define PERDecodeConsBIT_STRING(Coder, Info) PERConstructedDecode(Coder, Info)

/*************************************************/

/* Low bound of constraint */
#define PERBitStringLBound(iType) ((tASN1BitString*)iType)->SizeConstraint.LBound
/* Up bound of constraint */
#define PERBitStringUBound(iType) ((tASN1BitString*)iType)->SizeConstraint.pUBound
/* Extension marker */
#define PERBitStringExtMarker(iType) ((tASN1BitString*)iType)->SizeConstraint.ExtMarker

/**************************************************
 * NAME: PEREncodeBIT_STRING
 *       
 *
 */

static void
PEREncodeBIT_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{  
  tPERConstructedInfo BitStringInfo;
  tVMSString vBitString;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeBIT_STRING\n");
#endif

  VMSGetBIT_STRING(Coder, Val, Type, vBitString);

  VALUE_ERROR_HANDLER_EXP((Coder->EMS.ErrorCode =
                          CUCFCheckBIT_STRING(Coder, Type, &vBitString)) != ec_SUCCESS,
                          Coder,
                          return,
                          Coder->EMS.ErrorCode,
                          ERR_ARG("BIT STRING"));

  if (vBitString.Length == 0)
    {
      if (PERBitStringExtMarker(Type) == em_Present)
        {
          if(PERBitStringLBound(Type) > 0)
            PERPutBit(Coder, 1);
          else
            PERPutBit(Coder, 0);
        }

      if (Coder->ER.Rule & er_Aligned)
        PERAlign(Coder);
      
      PERPutByte(Coder, 0);
      return;
    }
  else
    {
      BitStringInfo.Length = vBitString.Length;
      BitStringInfo.Value = vBitString.Value;
      BitStringInfo.PrimOp = (tPERPrimFunc)PEREncodePrimBIT_STRING;
    }

  if (PERBitStringExtMarker(Type) == em_Present)
    {
      if ((vBitString.Length < (tVMSULong)PERBitStringLBound(Type)) || 
          ((((tASN1BitString*)Type)->ConstraintMask) && (vBitString.Length > (tVMSULong)PERBitStringUBound(Type))))
        {
          PERPutBit(Coder, 1);
          PEREncodeConsBIT_STRING(Coder, &BitStringInfo);
          VMSFreeString(Coder, vBitString);
          return;
        }
      else
        PERPutBit(Coder, 0);
    }

  if (((tASN1BitString*)Type)->ConstraintMask)
    {
      if (PERBitStringLBound(Type) == PERBitStringUBound(Type))
        {
          if (PERBitStringLBound(Type) == 0) { /* Nothing */ }
          else
          if (PERBitStringLBound(Type) <= 0x10)
            PEREncodePrimBIT_STRING(Coder, PERBitStringLBound(Type), &BitStringInfo);
          else
          if (PERBitStringLBound(Type) < 0x10000)
            {
              if (Coder->ER.Rule & er_Aligned)
                PERAlign(Coder);

              PEREncodePrimBIT_STRING(Coder, PERBitStringLBound(Type), &BitStringInfo);
            }
          else
            PEREncodeConsBIT_STRING(Coder, &BitStringInfo);
        }
      else
        {
          if (PERBitStringUBound(Type) < 0x10000)
            {
              PEREncodeConstrainedWholeNumber(Coder, PERBitStringLBound(Type), PERBitStringUBound(Type), vBitString.Length);
              if (Coder->ER.Rule & er_Aligned)
                PERAlign(Coder);

              PEREncodePrimBIT_STRING(Coder, vBitString.Length, &BitStringInfo);
            }
          else
            PEREncodeConsBIT_STRING(Coder, &BitStringInfo);
        }
    }
  else
    PEREncodeConsBIT_STRING(Coder, &BitStringInfo);

  VMSFreeString(Coder, vBitString);
}

/**************************************************
 * NAME: PERDecodeBIT_STRING
 *       
 *
 */

static void
PERDecodeBIT_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tPERConstructedInfo BitStringInfo;
  tVMSString vBitString;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeBIT_STRING\n");
#endif

  /* Init Info */
  BitStringInfo.Value = NULL;
  BitStringInfo.Length = 0;
  BitStringInfo.PrimOp = (tPERPrimFunc)PERDecodePrimBIT_STRING;

  if ((PERBitStringExtMarker(Type) == em_Present) && (PERGetBit(Coder) == 1))
    PERDecodeConsBIT_STRING(Coder, &BitStringInfo);
  else
  if (((tASN1BitString*)Type)->ConstraintMask)
    {
      if (PERBitStringLBound(Type) == PERBitStringUBound(Type))
        {
          if (PERBitStringLBound(Type) == 0) { /* Nothing */ }
          else
          if (PERBitStringLBound(Type) <= 0x10)
            PERDecodePrimBIT_STRING(Coder, PERBitStringLBound(Type), &BitStringInfo);
          else
          if (PERBitStringLBound(Type) < 0x10000)
            {
              if (Coder->ER.Rule & er_Aligned)
                PERAlign(Coder);

              PERDecodePrimBIT_STRING(Coder, PERBitStringLBound(Type), &BitStringInfo);
            }
          else
            PERDecodeConsBIT_STRING(Coder, &BitStringInfo);
        }
      else
        {
          if (PERBitStringUBound(Type) < 0x10000)
            {             
              tVMSULong Length = 0;

              PERDecodeConstrainedWholeNumber(Coder, PERBitStringLBound(Type), PERBitStringUBound(Type), (tVMSInteger*)&Length);
              if (Coder->ER.Rule & er_Aligned)
                PERAlign(Coder);

              PERDecodePrimBIT_STRING(Coder, Length, &BitStringInfo);
            }
          else
            PERDecodeConsBIT_STRING(Coder, &BitStringInfo);
        }
    }
  else
    PERDecodeConsBIT_STRING(Coder, &BitStringInfo);

  vBitString.IsAssigned = 0;
  vBitString.Value = BitStringInfo.Value;
  vBitString.Length = BitStringInfo.Length;

  VMSSetBIT_STRING(Coder, Val, Type, vBitString);

  VALUE_ERROR_HANDLER_EXP((Coder->EMS.ErrorCode =
                          CUCFCheckBIT_STRING(Coder, Type, &vBitString)) != ec_SUCCESS,
                          Coder,
                          return,
                          Coder->EMS.ErrorCode,
                          ERR_ARG("BIT STRING"));

  VMSFreeString(Coder, vBitString);
}
#endif /* CODER_NOUSE_BIT_STRING */


#ifndef CODER_NOUSE_OCTET_STRING
/*************************************************/
/**************** OCTET STRING *******************/
/*************************************************/

/**************************************************
 * NAME: PEREncodePrimOCTET_STRING
 *       
 *
 */

static void
PEREncodePrimOCTET_STRING(tCoder* Coder, tVMSULong Length, tPERConstructedInfo* Info)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodePrimOCTET_STRING\n");
#endif

  PERPutSeg(Coder, (unsigned char*)Info->Value, Length);
  Info->Value = (unsigned char*)Info->Value + Length;
  Info->Length -= Length;
}


/**************************************************
 * NAME: PERDecodePrimOCTET_STRING
 *       
 *
 */

static void
PERDecodePrimOCTET_STRING(tCoder* Coder, tVMSULong Length, tPERConstructedInfo* Info)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodePrimOCTET_STRING\n");
#endif

  if (Length > 0)
    {
      unsigned char* CurrStrVal;

      VMSAllocOCTET_STRING(Coder, (*Info), CurrStrVal, Length);

      if (Coder->ER.BitCurr != 7)
        {
          PERBUF_ERROR_HANDLER_EXP((tVMSULong)(Coder->ER.DataEnd - Coder->ER.DataCurr), Length + 1, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
          for (; Length > 0; Length--, CurrStrVal++)
            {
              *CurrStrVal = (unsigned char)(*(Coder->ER.DataCurr) << ((7 - Coder->ER.BitCurr)));
              Coder->ER.DataCurr++;
              *CurrStrVal |= (unsigned char)(*(Coder->ER.DataCurr) >> (Coder->ER.BitCurr + 1));
            }          
        }
      else
        {
          PERBUF_ERROR_HANDLER_EXP((tVMSULong)(Coder->ER.DataEnd - Coder->ER.DataCurr), Length, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);

          memcpy(CurrStrVal, Coder->ER.DataCurr, Length);
          Coder->ER.DataCurr += Length;
        }
    }
}

/**************************************************
 * NAME: PEREncodeConsOCTET_STRING
 */

#define PEREncodeConsOCTET_STRING(Coder, Info) PERConstructedEncode(Coder, Info)

/**************************************************
 * NAME: PERDecodeConsOCTET_STRING
 */

#define PERDecodeConsOCTET_STRING(Coder, Info) PERConstructedDecode(Coder, Info)

/*************************************************/

/* Low bound of constraint */
#define PEROctetStringLBound(iType) ((tASN1OctetString*)iType)->SizeConstraint.LBound
/* Up bound of constraint */
#define PEROctetStringUBound(iType) ((tASN1OctetString*)iType)->SizeConstraint.pUBound
/* Extension marker */
#define PEROctetStringExtMarker(iType) ((tASN1OctetString*)iType)->SizeConstraint.ExtMarker

/**************************************************
 * NAME: PEREncodeOCTET_STRING
 *       
 *
 */

static void
PEREncodeOCTET_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tPERConstructedInfo OctetStringInfo;
  tVMSString vOctetString;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeOCTET_STRING\n");
#endif

  VMSGetOCTET_STRING(Coder, Val, Type, vOctetString);

  VALUE_ERROR_HANDLER_EXP((Coder->EMS.ErrorCode =
                          CUCFCheckOCTET_STRING(Coder, Type, &vOctetString)) != ec_SUCCESS,
                          Coder,
                          return,
                          Coder->EMS.ErrorCode,
                          ERR_ARG("OCTET STRING"));

  if (vOctetString.Length == 0)
    {
      if (PEROctetStringExtMarker(Type) == em_Present)
        {
          if(PEROctetStringLBound(Type) > 0)
            PERPutBit(Coder, 1);
          else
            PERPutBit(Coder, 0);
        }

      if (Coder->ER.Rule & er_Aligned)
        PERAlign(Coder);

      PERPutByte(Coder, 0);
      return;
    }
  else
    {
      OctetStringInfo.Length = vOctetString.Length;
      OctetStringInfo.Value = vOctetString.Value;
      OctetStringInfo.PrimOp = (tPERPrimFunc)PEREncodePrimOCTET_STRING;
    }

  if (PEROctetStringExtMarker(Type) == em_Present)
    {
      tVMSULong OSLength = OctetStringInfo.Length;

      if ((OSLength < (tVMSULong)PEROctetStringLBound(Type)) ||
          ((((tASN1OctetString*)Type)->ConstraintMask) && (OSLength > (tVMSULong)PEROctetStringUBound(Type))))
        {
          PERPutBit(Coder, 1);
          PEREncodeConsOCTET_STRING(Coder, &OctetStringInfo);
          VMSFreeString(Coder, vOctetString);
          return;
        }
      else
        PERPutBit(Coder, 0);
    }
  
  if (((tASN1OctetString*)Type)->ConstraintMask)
    {
      if (PEROctetStringLBound(Type) == PEROctetStringUBound(Type))
        {
          if (PEROctetStringLBound(Type) == 0) { /* Nothing */ }
          else
          if (PEROctetStringLBound(Type) <= 0x2)
            PEREncodePrimOCTET_STRING(Coder, PEROctetStringLBound(Type), &OctetStringInfo);
          else
          if (PEROctetStringLBound(Type) < 0x10000)
            {
              if (Coder->ER.Rule & er_Aligned)
                PERAlign(Coder);

              PEREncodePrimOCTET_STRING(Coder, PEROctetStringLBound(Type), &OctetStringInfo);
            }
          else
            PEREncodeConsOCTET_STRING(Coder, &OctetStringInfo);
        }
      else
      if (PEROctetStringUBound(Type) < 0x10000)
        {
          PEREncodeConstrainedWholeNumber(Coder, PEROctetStringLBound(Type), PEROctetStringUBound(Type), OctetStringInfo.Length);
          if (Coder->ER.Rule & er_Aligned)
            PERAlign(Coder);

          PEREncodePrimOCTET_STRING(Coder, OctetStringInfo.Length, &OctetStringInfo);
        }
      else
        PEREncodeConsOCTET_STRING(Coder, &OctetStringInfo);
    }
  else
    PEREncodeConsOCTET_STRING(Coder, &OctetStringInfo);

  VMSFreeString(Coder, vOctetString);
}

/**************************************************
 * NAME: PERDecodeOCTET_STRING
 *       
 *
 */

static void
PERDecodeOCTET_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tPERConstructedInfo OctetStringInfo;
  tVMSString vOctetString;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeOCTET_STRING\n");
#endif

  /* Init Info */
  OctetStringInfo.Value = NULL;
  OctetStringInfo.Length = 0;
  OctetStringInfo.PrimOp = (tPERPrimFunc)PERDecodePrimOCTET_STRING;

  if ((PEROctetStringExtMarker(Type) == em_Present) && (PERGetBit(Coder) == 1))
    PERDecodeConsOCTET_STRING(Coder, &OctetStringInfo);
  else
  if (((tASN1OctetString*)Type)->ConstraintMask)
    {
      if (PEROctetStringLBound(Type) == PEROctetStringUBound(Type))
        {
          if (PEROctetStringLBound(Type) == 0) { /* Nothing */ }
          else
          if (PEROctetStringLBound(Type) <= 0x2)
            PERDecodePrimOCTET_STRING(Coder, PEROctetStringLBound(Type), &OctetStringInfo);
          else
          if (PEROctetStringLBound(Type) < 0x10000)
            {
              if (Coder->ER.Rule & er_Aligned)
                PERAlign(Coder);

              PERDecodePrimOCTET_STRING(Coder, PEROctetStringLBound(Type), &OctetStringInfo);
            }
          else
            PERDecodeConsOCTET_STRING(Coder, &OctetStringInfo);
        }
      else
      if (PEROctetStringUBound(Type) < 0x10000)
        {
          tVMSULong Length;

          PERDecodeConstrainedWholeNumber(Coder, PEROctetStringLBound(Type), PEROctetStringUBound(Type), (tVMSInteger*)&Length);
          if (Coder->ER.Rule & er_Aligned)
            PERAlign(Coder);

          PERDecodePrimOCTET_STRING(Coder, Length, &OctetStringInfo);
        }
      else
        PERDecodeConsOCTET_STRING(Coder, &OctetStringInfo);
    }
  else
    PERDecodeConsOCTET_STRING(Coder, &OctetStringInfo);

  vOctetString.Value = OctetStringInfo.Value;
  vOctetString.Length = OctetStringInfo.Length;

  VMSSetOCTET_STRING(Coder, Val, Type, vOctetString);

  VALUE_ERROR_HANDLER_EXP((Coder->EMS.ErrorCode =
                          CUCFCheckOCTET_STRING(Coder, Type, &vOctetString)) != ec_SUCCESS,
                          Coder,
                          return,
                          Coder->EMS.ErrorCode,
                          ERR_ARG("OCTET STRING"));
  
  VMSFreeString(Coder, vOctetString);
}
#endif /* CODER_NOUSE_OCTET_STRING */


#ifndef CODER_NOUSE_CHARACTER_STRING
/*************************************************/
/************** CHARACTER STRING *****************/
/*************************************************/

#define SymbToNum(InAlphabet, InAlphabetLen, InSymb, OutNum) \
{ \
  unsigned long __i; \
  unsigned char* __curr_alpha = InAlphabet; \
  for (__i = 0; (*__curr_alpha != InSymb) && (__i < InAlphabetLen); __i++, __curr_alpha++ ); \
  OutNum = __i; \
}

/**************************************************
 * NAME: PEREncodePrimCHARACTER_STRING
 *       
 *
 */
static void
PEREncodePrimCHARACTER_STRING(tCoder* Coder, tVMSULong Length, tPERConstructedInfo* Info)
{
  tVMSULong CurrLength = Length;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodePrimCHARACTER_STRING\n");
#endif

  if (((tPERCharStringInfo*)Info)->ValMask == 1) /* Number */
    {
      tVMSULong Number;
      
      while (CurrLength > 0)
        {
          SymbToNum((((tPERCharStringInfo*)Info)->Alphabet),
                    (((tPERCharStringInfo*)Info)->AlphabetLen),
                    (*(char*)(Info->Value)), Number);
          
          PEREncodeNonNegativeBinaryINTEGER(Coder, Number,
                                            ((tPERCharStringInfo*)Info)->BitsLength);
          Info->Value = Info->Value + 1;
          CurrLength--;
        }
    }
  else 
    {
      while(CurrLength > 0)
        {
          PEREncodeNonNegativeBinaryINTEGER(Coder, (tVMSULong)(*(unsigned char*)(Info->Value)),
					    ((tPERCharStringInfo*)Info)->BitsLength);
          Info->Value = (unsigned char*)(Info->Value) + 1;
          CurrLength--;
        }      
    }
}

/**************************************************
 * NAME: PERDecodePrimCHARACTER_STRING
 *       
 *
 */

static void
PERDecodePrimCHARACTER_STRING(tCoder* Coder, tVMSULong Length, tPERConstructedInfo* Info)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodePrimCHARACTER_STRING\n");
#endif

  if (Length > 0)
    {
      tVMSULong Byte;
      unsigned char* CurrStrVal;

      VMSAllocCHARACTER_STRING(Coder, (*Info), CurrStrVal, Length);

      for (; Length > 0; Length--, CurrStrVal++)
        {
          PERDecodeNonNegativeBinaryINTEGER(Coder, ((tPERCharStringInfo*)Info)->BitsLength, Byte);
          *CurrStrVal = (unsigned char)Byte;
        }
    }
}

/**************************************************
 * NAME: PEREncodeConsCHARACTER_STRING
 */

#define PEREncodeConsCHARACTER_STRING(Coder, Info) PERConstructedEncode(Coder, (tPERConstructedInfo*)Info)

/**************************************************
 * NAME: PERDecodeConsCHARACTER_STRING
 */

#define PERDecodeConsCHARACTER_STRING(Coder, Info) PERConstructedDecode(Coder, (tPERConstructedInfo*)Info)

/*************************************************/

/* Low bound of constraint */
#define PERCharStringLBound(iType) ((tASN1CharString*)iType)->SizeConstraint.LBound
/* Up bound of constraint */
#define PERCharStringUBound(iType) (((tASN1CharString*)iType)->SizeConstraint.pUBound)
/* Extension marker */
#define PERCharStringExtMarker(iType) ((tASN1CharString*)iType)->SizeConstraint.ExtMarker

/**************************************************
 * NAME: PEREncodeCHARACTER_STRING
 *       
 *
 */

static void
PEREncodeCHARACTER_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tPERCharStringInfo CharStringInfo;
  tVMSString vCharString;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeCHARACTER_STRING\n");
#endif

  switch (Type->TypeClass)
    {
    case type_ASN1_NumericString:
      VMSGetNumericString(Coder, Val, Type, vCharString);
      break;
    case type_ASN1_PrintableString:
      VMSGetPrintableString(Coder, Val, Type, vCharString);
      break;
    case type_ASN1_IA5String:
      VMSGetIA5String(Coder, Val, Type, vCharString);
      break;
    case type_ASN1_VisibleString:
      VMSGetVisibleString(Coder, Val, Type, vCharString);
      break;
    case type_ASN1_GeneralizedTime:
      VMSGetGeneralizedTime(Coder, Val, Type, vCharString);
      break;
    case type_ASN1_UTCTime:
      VMSGetUTCTime(Coder, Val, Type, vCharString);
      break;
    default:
      INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
    }

  VALUE_ERROR_HANDLER_EXP((Coder->EMS.ErrorCode =
                          CUCFCheckCHARACTER_STRING(Coder, Type, &vCharString)) != ec_SUCCESS,
                          Coder,
                          return,
                          Coder->EMS.ErrorCode,
                          ERR_ARG("Character String"));

  if(vCharString.Length == 0)
    {
      if (PERCharStringExtMarker(Type) == em_Present)
        {
          if(PERCharStringLBound(Type) > 0)
            PERPutBit(Coder, 1);
          else
            PERPutBit(Coder, 0);
        }

      if (Coder->ER.Rule & er_Aligned)
        PERAlign(Coder);

      PERPutByte(Coder, 0);
      return;
    }
  else
    {
      CharStringInfo.Length = vCharString.Length;
      CharStringInfo.Value = vCharString.Value;
      CharStringInfo.ValMask = 0;  /* Code == 0, Number == 1 */
      CharStringInfo.PrimOp = (tPERPrimFunc)PEREncodePrimCHARACTER_STRING;
    }

  if(((tASN1CharString*)Type)->AlphabetLen > 0)
    {
      tVMSULong CurrNumber;
      char AUBound;

      CharStringInfo.Alphabet = ((tASN1CharString*)Type)->Alphabet;
      CharStringInfo.AlphabetLen = ((tASN1CharString*)Type)->AlphabetLen;
      CurrNumber = CharStringInfo.AlphabetLen;
      AUBound = CharStringInfo.Alphabet[CurrNumber - 1];

      CharStringInfo.BitsLength = 0;

      while (CurrNumber > 0)
        {
          CurrNumber >>= 1;
          CharStringInfo.BitsLength++;
        }

      if (CharStringInfo.AlphabetLen <= 2)
        CharStringInfo.BitsLength--;

      if (Coder->ER.Rule & er_Aligned)
        {
          unsigned char TmpBits = 1;
          
          CurrNumber = CharStringInfo.BitsLength;
          while (CurrNumber > 0)
            {
              CurrNumber >>= 1;
              TmpBits <<= 1;
            }
          
          CharStringInfo.BitsLength = (unsigned char)((CharStringInfo.BitsLength > (TmpBits >> 1)) ? 
                                       TmpBits : (TmpBits >> 1));
        }      
      
      if (AUBound > (unsigned char)((1 << CharStringInfo.BitsLength) - 1))
        CharStringInfo.ValMask = 1; /* Number */
    }
  else
    {
      switch(Type->TypeClass)
        {
        case type_ASN1_NumericString:
          CharStringInfo.BitsLength = 4;
          CharStringInfo.ValMask = 1; /* Number */
          CharStringInfo.Alphabet = (unsigned char*)" 0123456789";
          CharStringInfo.AlphabetLen = 11;
          break;
        case type_ASN1_PrintableString:
        case type_ASN1_IA5String:
        case type_ASN1_VisibleString:
        case type_ASN1_GeneralizedTime:
        case type_ASN1_UTCTime:
          CharStringInfo.Alphabet = NULL;
          CharStringInfo.AlphabetLen = 0;

          if (Coder->ER.Rule & er_Aligned)
            CharStringInfo.BitsLength = 8;
          else
            CharStringInfo.BitsLength = 7;
          break;
        default:
          INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
        }
    }

  if (PERCharStringExtMarker(Type) == em_Present)
    {
      if((vCharString.Length < (tVMSULong)PERCharStringLBound(Type)) ||
         ((((tASN1CharString*)Type)->ConstraintMask) && (vCharString.Length > (tVMSULong)PERCharStringUBound(Type))))
        {
          PERPutBit(Coder, 1);
          PEREncodeConsCHARACTER_STRING(Coder, &CharStringInfo);

          VMSFreeString(Coder, vCharString);
          return;
        }
      else
        PERPutBit(Coder, 0);
    }

  if (((tASN1CharString*)Type)->ConstraintMask)
    {
      if (PERCharStringLBound(Type) == PERCharStringUBound(Type))
        {
          if (PERCharStringLBound(Type) == 0) { /* Nothing */ }
          else
          if (PERCharStringLBound(Type) <= 0x2)
            PEREncodePrimCHARACTER_STRING(Coder, PERCharStringLBound(Type), (tPERConstructedInfo*)&CharStringInfo);
          else
          if (PERCharStringLBound(Type) < 0x10000)
            {
              if ((Coder->ER.Rule & er_Aligned) && (PERCharStringLBound(Type) * CharStringInfo.BitsLength > 16))
                PERAlign(Coder);
              PEREncodePrimCHARACTER_STRING(Coder, PERCharStringLBound(Type), (tPERConstructedInfo*)&CharStringInfo);
            }
          else
            PEREncodeConsCHARACTER_STRING(Coder, &CharStringInfo);
        }
      else
        {
          if (PERCharStringUBound(Type) - PERCharStringLBound(Type) + 1 < 0x10000)
            {
              PEREncodeConstrainedWholeNumber(Coder, PERCharStringLBound(Type), PERCharStringUBound(Type), vCharString.Length);
              if (Coder->ER.Rule & er_Aligned)
                PERAlign(Coder);

              PEREncodePrimCHARACTER_STRING(Coder, vCharString.Length, (tPERConstructedInfo*)&CharStringInfo);
            }
          else
            PEREncodeConsCHARACTER_STRING(Coder, &CharStringInfo);
        }
    }
  else
    PEREncodeConsCHARACTER_STRING(Coder, &CharStringInfo);

  VMSFreeString(Coder, vCharString);
}

/**************************************************
 * NAME: PERDecodeCHARACTER_STRING
 *       
 *
 */

static void
PERDecodeCHARACTER_STRING(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tPERCharStringInfo CharStringInfo;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeCharString\n");
#endif

  /* Init */
  CharStringInfo.Value = NULL;
  CharStringInfo.Length = 0;
  CharStringInfo.ValMask = 0; /* Code */
  CharStringInfo.AlphabetLen = ((tASN1CharString*)Type)->AlphabetLen;
  CharStringInfo.PrimOp = (tPERPrimFunc)PERDecodePrimCHARACTER_STRING;

  if (CharStringInfo.AlphabetLen > 0)
    {
      tVMSULong CurrNumber = CharStringInfo.AlphabetLen;

      CharStringInfo.BitsLength = 0;
      
      while (CurrNumber > 0)
        {
          CurrNumber >>= 1;
          CharStringInfo.BitsLength++;
        }

      if (CharStringInfo.AlphabetLen <= 2)
        CharStringInfo.BitsLength--;

      if (Coder->ER.Rule & er_Aligned)
        {
          unsigned char TmpBits = 1;
          
          CurrNumber = CharStringInfo.BitsLength;
          while (CurrNumber > 0)
            {
              CurrNumber >>= 1;
              TmpBits <<= 1;
            }
          
          CharStringInfo.BitsLength = (unsigned char)((CharStringInfo.BitsLength > (TmpBits >> 1)) ?
                                       TmpBits : (TmpBits >> 1));
        }
    }
  else
    {
      switch (Type->TypeClass)
        {
        case type_ASN1_NumericString:
          CharStringInfo.BitsLength = 4;
          break;
        case type_ASN1_PrintableString:
        case type_ASN1_IA5String:
        case type_ASN1_VisibleString:
        case type_ASN1_GeneralizedTime:
        case type_ASN1_UTCTime:
          if (Coder->ER.Rule & er_Aligned)
            CharStringInfo.BitsLength = 8;
          else
            CharStringInfo.BitsLength = 7;
          break;
        default:
          INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
        }
    }

  if ((PERCharStringExtMarker(Type) == em_Present) && (PERGetBit(Coder) == 1))
    PERDecodeConsCHARACTER_STRING(Coder, &CharStringInfo);
  else
  if (((tASN1CharString*)Type)->ConstraintMask)
    {
      if (PERCharStringLBound(Type) == PERCharStringUBound(Type))
        {
          if (PERCharStringLBound(Type) == 0) { /* Nothing */ }
          else
          if (PERCharStringLBound(Type) <= 0x2)
            PERDecodePrimCHARACTER_STRING(Coder, PERCharStringLBound(Type), (tPERConstructedInfo*)&CharStringInfo);
          else 
          if (PERCharStringLBound(Type) < 0x10000)
            {
              if ((Coder->ER.Rule & er_Aligned) && (PERCharStringLBound(Type) * CharStringInfo.BitsLength > 16))
                PERAlign(Coder);
              PERDecodePrimCHARACTER_STRING(Coder, PERCharStringLBound(Type), (tPERConstructedInfo*)&CharStringInfo);
            }
          else
            PERDecodeConsCHARACTER_STRING(Coder, &CharStringInfo);
        }
      else
        {
          if (PERCharStringUBound(Type) - PERCharStringLBound(Type) + 1 < 0x10000)
            {
              tVMSULong Length;

              PERDecodeConstrainedWholeNumber(Coder, PERCharStringLBound(Type), PERCharStringUBound(Type), (tVMSInteger*)&Length);
              if (Coder->ER.Rule & er_Aligned)
                PERAlign(Coder);

              PERDecodePrimCHARACTER_STRING(Coder, Length, (tPERConstructedInfo*)&CharStringInfo);
            }
          else
            PERDecodeConsCHARACTER_STRING(Coder, &CharStringInfo);
        }
    }
  else
    PERDecodeConsCHARACTER_STRING(Coder, &CharStringInfo);

  if (CharStringInfo.AlphabetLen > 0)
    {
      tVMSString_Value Alphabet = ((tASN1CharString*)Type)->Alphabet;
      char AUBound = Alphabet[CharStringInfo.AlphabetLen - 1];
      if (AUBound > (unsigned char)((1 << CharStringInfo.BitsLength) - 1))
        {
          char* CurrChar =  (char*)CharStringInfo.Value;
          tVMSULong StrLen = CharStringInfo.Length;
          
          while (StrLen > 0)
            {
              *CurrChar = Alphabet[(int)(*CurrChar)];
              CurrChar++;
              StrLen--;
            }
        }
    }
  else
    {
      if (Type->TypeClass == type_ASN1_NumericString)
        {
          register char* CurrChar = (char*)CharStringInfo.Value;
          tVMSULong StrLen = CharStringInfo.Length;
		  tVMSString_Value Alphabet = (unsigned char*)" 0123456789";

          while (StrLen > 0)
            {
              *CurrChar = Alphabet[(int)(*CurrChar)];
              CurrChar++;
              StrLen--;
            }
        }
    }

  {
    tVMSString vCharString;

    vCharString.Value = CharStringInfo.Value;
    vCharString.Length = CharStringInfo.Length;
    
    switch (Type->TypeClass)
      {
      case type_ASN1_NumericString:
        VMSSetNumericString(Coder, Val, Type, vCharString);
        break;
      case type_ASN1_PrintableString:
        VMSSetPrintableString(Coder, Val, Type, vCharString);
        break;
      case type_ASN1_IA5String:
        VMSSetIA5String(Coder, Val, Type, vCharString);
        break;
      case type_ASN1_VisibleString:
        VMSSetVisibleString(Coder, Val, Type, vCharString);
        break;
      case type_ASN1_GeneralizedTime:
        VMSSetGeneralizedTime(Coder, Val, Type, vCharString);
        break;
      case type_ASN1_UTCTime:
        VMSSetUTCTime(Coder, Val, Type, vCharString);
        break;
      default:
        INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
      }

    VALUE_ERROR_HANDLER_EXP((Coder->EMS.ErrorCode =
                            CUCFCheckCHARACTER_STRING(Coder, Type, &vCharString)) != ec_SUCCESS,
                            Coder,
                            return,
                            Coder->EMS.ErrorCode,
                            ERR_ARG("Character String"));


    VMSFreeString(Coder, vCharString);
  }
}
#endif /* CODER_NOUSE_CHARACTER_STRING */


#if !defined(CODER_NOUSE_ENUMERATED) || !defined(CODER_NOUSE_CHOICE)
/*************************************************/
/******** SHARED "ENUMERATED" FUNCTIONS **********/
/*************************************************/

/**************************************************
 * NAME: PEREncodeNormallySmallNonNegativeWholeNumber
 *       
 *
 */

static void
PEREncodeNormallySmallNonNegativeWholeNumber(tCoder* Coder, tVMSULong Val)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeNormallySmallNonNegativeWholeNumber\n");
#endif                                                                                  

  if (Val < 0x3f) /* <= was changed to < */
    {
      /* 1 bit: 0; 6 bits: number */
      PEREncodeNonNegativeBinaryINTEGER(Coder, Val, 7);
    }
  else /* (number >= 0x3f) */
    {
      PERPutBit(Coder, 1);
      PEREncodeSemiConstrainedWholeNumber(Coder, 0, Val);
    }
}

/**************************************************
 * NAME: PERDecodeNormallySmallNonNegativeSmallNumber
 *       
 *
 */

static void
PERDecodeNormallySmallNonNegativeWholeNumber(tCoder* Coder, tVMSULong* Val)
{
  char Bit;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeNormallySmallNonNegativeWholeNumber\n");
#endif                                                                                  

  Bit = PERGetBit(Coder);
  if (Bit == 0)
    PERDecodeNonNegativeBinaryINTEGER(Coder, 6, *Val);
  else /* (number >= 0x3f) */
    PERDecodeSemiConstrainedWholeNumber(Coder, 0, (tVMSInteger*)Val);
}
#endif /* !defined(CODER_NOUSE_ENUMERATED) || !defined(CODER_NOUSE_CHOICE) */

#ifndef CODER_NOUSE_ENUMERATED
/*************************************************/
/***************** ENUMERATED ********************/
/*************************************************/

/**************************************************
 * NAME: PEREncodeENUMERATED
 *       
 *
 */

static void
PEREncodeENUMERATED(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tVMSULong  MaxIndex = ((tASN1Enumerated*)Type)->NumOfItems - 1;
  tVMSEnumerated_Index  EnumIndex;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeENUMERATED\n");
#endif                                                                                  

  VMSGetIndexENUMERATED(Coder, Val, Type, EnumIndex);

  INTERNAL_ERROR_HANDLER_EXP((EnumIndex == MaxIndex + 1), Coder, return, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));

  if (((tASN1Enumerated*)Type)->ExtMarker != -1)
    {
      if (EnumIndex >= (tVMSEnumerated_Index)(((tASN1Enumerated*)Type)->ExtMarker))
        {
          PERPutBit(Coder, 1);
          PEREncodeNormallySmallNonNegativeWholeNumber(Coder, EnumIndex - ((tASN1Enumerated*)Type)->ExtMarker);
        }
      else
        {
          PERPutBit(Coder, 0);
          PEREncodeConstrainedWholeNumber(Coder, 0, ((tASN1Enumerated*)Type)->ExtMarker - 1, EnumIndex);
        }
    }
  else
    PEREncodeConstrainedWholeNumber(Coder, 0, MaxIndex, EnumIndex);
}

/**************************************************
 * NAME: PERDecodeENUMERATED
 *       
 *
 */

static void
PERDecodeENUMERATED(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  tVMSULong  MaxIndex = ((tASN1Enumerated*)Type)->NumOfItems - 1;
  tVMSEnumerated_Index  EnumIndex;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeENUMERATED\n");
#endif

  if (((tASN1Enumerated*)Type)->ExtMarker != -1)
    {
      unsigned char Bit = PERGetBit(Coder);

      if (Bit == 1)
        {
          PERDecodeNormallySmallNonNegativeWholeNumber(Coder, (tVMSULong*)&EnumIndex);
          EnumIndex += ((tASN1Enumerated*)Type)->ExtMarker;
        }
      else
        PERDecodeConstrainedWholeNumber(Coder, 0, ((tASN1Enumerated*)Type)->ExtMarker - 1, (tVMSInteger*)&EnumIndex);
    }
  else
    PERDecodeConstrainedWholeNumber(Coder, 0, MaxIndex, (tVMSInteger*)&EnumIndex);

  VMSSetIndexENUMERATED(Coder, Val, Type, EnumIndex);
}
#endif /* CODER_NOUSE_ENUMERATED */


#if !defined(CODER_NOUSE_CHOICE) || !defined(CODER_NOUSE_OPEN) || !defined(CODER_NOUSE_EXT)
/*************************************************/
/******************* SHARED **********************/
/*************************************************/

/**************************************************
 * NAME: PEREncodeOPENTypeField
 *       
 *
 */

static void
PEREncodeOPENTypeField(tCoder* Coder, tASN1TypeInfo *Type, void* Val)
{
  tVMSULong StartPos, Length;
  unsigned char StartBit;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeOPENTypeField\n");
#endif

  if (Coder->ER.Rule & er_Aligned)
    { PERAlign(Coder); }

  StartPos = Coder->ER.DataCurr - Coder->ER.DataEnd;
  StartBit = Coder->ER.BitCurr;

  PERSkipBytes(Coder, 1);

  PEREncVal(Coder, Type, Val);
  Length = (Coder->ER.DataCurr - Coder->ER.DataEnd) - (StartPos + 1);

  if (StartBit > Coder->ER.BitCurr)
    {
      PERPutBits(Coder, 0, (unsigned char)(8 - (StartBit - Coder->ER.BitCurr)));
      Length += 1;
    }
  else
  if (Length > 0)
    PERPutBits(Coder, 0, (unsigned char)(Coder->ER.BitCurr - StartBit));

  if (Length == 0)
    {
      Coder->ER.DataCurr--;
      PERPutBits(Coder, 0x0100, 16);
    }
  else
  if (Length <= 0x7f)
    {
      unsigned char* CurrByte = Coder->ER.DataEnd + StartPos;

      if (Coder->ER.BitCurr != 7)
        {
          *CurrByte |= (unsigned char)(Length >> (7 - Coder->ER.BitCurr));
          CurrByte++;
          *CurrByte |= (unsigned char)(Length << (Coder->ER.BitCurr + 1));
        }
      else
        *CurrByte = (unsigned char)Length;
    }
  else
    {
      if (Coder->ER.BitCurr == 7)
        PEROctetsFragmentation(Coder, Length);
      else
        PEROctetsFragmentationWithOffset(Coder, Length);
    }
}

/**************************************************
 * NAME: PERDecodeOPENTypeField
 *       
 *
 */

static void
PERDecodeOPENTypeField(tCoder* Coder, tASN1TypeInfo *Type, void* Val, tVMSOpenTypeList* List)
{
  unsigned char Byte;
  tVMSULong Length;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeOPENTypeField\n");
#endif

  if (Coder->ER.Rule & er_Aligned)
    PERAlign(Coder);

  Byte = PERGetByte(Coder);

  if (Byte >= 0xC1)
    {
      Coder->ER.DataCurr--;
      if (Coder->ER.BitCurr != 7)
        {
          Length = PEROctetsDefragmentationWithOffset(Coder);
          PERDecVal(Coder, Type, Val, List);
          PEROctetsFragmentationWithOffset(Coder, Length);
        }
      else
        {
          Length = PEROctetsDefragmentation(Coder);
          PERDecVal(Coder, Type, Val, List);
          PEROctetsFragmentation(Coder, Length);
        }
    }
  else
  if((Byte & 0xC0) == 0x80)
    {
      unsigned char *EncByte, EncBit;

      Length = (((Byte & 0x7F) << 8) | PERGetByte(Coder));
      EncByte = Coder->ER.DataCurr + Length;
      EncBit = Coder->ER.BitCurr;
      PERDecVal(Coder, Type, Val, List);
      Coder->ER.DataCurr = EncByte;
      Coder->ER.BitCurr = EncBit;
    }
  else
  if((Byte & 0x80) == 0x00)
    {
      unsigned char *EncByte, EncBit;

      Length = (Byte & 0x7F);
      EncByte = Coder->ER.DataCurr + Length;
      EncBit = Coder->ER.BitCurr;
      PERDecVal(Coder, Type, Val, List);
      Coder->ER.DataCurr = EncByte;
      Coder->ER.BitCurr = EncBit;
    }
  else
    {
      DECODING_ERROR_HANDLER(Coder, return, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
    }
}
#endif /* !defined(CODER_NOUSE_CHOICE) || !defined(CODER_NOUSE_OPEN) || !defined(CODER_NOUSE_EXT) */

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET) || !defined(CODER_NOUSE_OPEN)
/**************************************************/
/**************************************************/
/**************************************************/

static void
PERSkipOPENTypeField(tCoder* Coder)
{
  unsigned char Byte;
  tVMSULong Length;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERSkipOPENTypeField\n");
#endif

  do
    {
      if (Coder->ER.Rule & er_Aligned)
        PERAlign(Coder);

      Byte = PERGetByte(Coder);

      if (Byte == 0xC4)
        Length = 0x10000;
      else
      if (Byte == 0xC3)
        Length = 0xC000;
      else
      if (Byte == 0xC2)
        Length = 0x8000;
      else
      if (Byte == 0xC1)
        Length = 0x4000;
      else
      if((Byte & 0xC0) == 0x80)
        Length = (((Byte & 0x7F) << 8) | PERGetByte(Coder));
      else
      if((Byte & 0x80) == 0x00)
        Length = (Byte & 0x7F);
      else
        {
          DECODING_ERROR_HANDLER(Coder, return, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
        }

      PERBUF_ERROR_HANDLER_EXP((tVMSULong)(Coder->ER.DataEnd - Coder->ER.DataCurr), Length, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
      Coder->ER.DataCurr += Length;
    }
  while(Length >= 0x4000);
}
#endif /* !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET) || !defined(CODER_NOUSE_OPEN) */

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)
/*************************************************/
/**************** SEQUENCE & SET *****************/
/*************************************************/

/**************************************************
 * NAME: PERSkipPrimBitField
 *       
 *
 */

static void
PERSkipPrimBitField(tCoder* Coder, tPEREncBitField* BitField, tVMSULong BFLength)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERSkipPrimBitField\n");
#endif
  
  BitField->CByte = Coder->ER.DataCurr - Coder->ER.DataEnd;
  BitField->CBit = Coder->ER.BitCurr;
  BitField->CLength = BFLength + 1;

  PERSkipBytes(Coder, (BFLength >> 3));
  PERPutBits(Coder, 0, (unsigned char)(BFLength & 0x7));
}

/**************************************************
 * NAME: PERGetPrimBitField
 *       
 *
 */

static void
PERGetPrimBitField(tCoder* Coder, tPERDecBitField* BitField, tVMSULong BFLength)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERGetPrimBitField\n");
#endif
  
  BitField->CByte = Coder->ER.DataCurr;
  BitField->CBit = Coder->ER.BitCurr;
  BitField->CLength = BFLength + 1;

  PERBUF_ERROR_HANDLER_EXP((tVMSULong)(Coder->ER.DataEnd - Coder->ER.DataCurr), (BFLength >> 3), Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
  Coder->ER.DataCurr += (BFLength >> 3);
  PERGetBits(Coder, (unsigned char)(BFLength & 0x7));
}

/**************************************************
 * NAME: PERSkipConsBitField
 *       
 *
 */

static void
PERSkipConsBitField(tCoder* Coder, tPEREncBitField* BitField, tVMSULong BFLength)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERSkipConsBitField\n");
#endif

  if (Coder->ER.Rule & er_Aligned)
    PERAlign(Coder);

  BitField->CLength = 0;
  
  while (BFLength >= 0x10000)
    {
      PERPutByte(Coder, 0xC4);
      if (BitField->CLength == 0)
        {
          BitField->CByte = Coder->ER.DataCurr - Coder->ER.DataEnd;
          BitField->CBit = Coder->ER.BitCurr;
          BitField->CLength = 0x10000;
        }
      PERSkipBytes(Coder, 0x2000);
      BFLength -= 0x10000;
    }    

  if (BFLength > 0xC000)
    {
      PERPutByte(Coder, 0xC3);
      if (BitField->CLength == 0)
        {
          BitField->CByte = Coder->ER.DataCurr - Coder->ER.DataEnd;
          BitField->CBit = Coder->ER.BitCurr;
          BitField->CLength = 0xC000;
        }
      PERSkipBytes(Coder, 0x1800);
      BFLength -= 0xC000;
    }
  
  if (BFLength >= 0x8000)
    {      
      PERPutByte(Coder, 0xC2);
      if (BitField->CLength == 0)
        {
          BitField->CByte = Coder->ER.DataCurr - Coder->ER.DataEnd;
          BitField->CBit = Coder->ER.BitCurr;
          BitField->CLength = 0x8000;
        }
      PERSkipBytes(Coder, 0x1000);
      BFLength -= 0x8000;
    }

  if (BFLength >= 0x4000)
    {
      PERPutByte(Coder, 0xC1);
      if (BitField->CLength == 0)
        {
          BitField->CByte = Coder->ER.DataCurr - Coder->ER.DataEnd;
          BitField->CBit = Coder->ER.BitCurr;
          BitField->CLength = 0x4000;
        }
      PERSkipBytes(Coder, 0x800);
      BFLength -= 0x4000;
    }

  if (BFLength <= 0x7F)
    PERPutByte(Coder, (unsigned char)BFLength);
  else
    PERPutBits(Coder, (BFLength | 0x8000), 16);
  
  if (BitField->CLength == 0)
    {
      BitField->CByte = Coder->ER.DataCurr - Coder->ER.DataEnd;
      BitField->CBit = Coder->ER.BitCurr;
      BitField->CLength = BFLength;
    }
  
  PERSkipBytes(Coder, (BFLength >> 3));
  PERPutBits(Coder, 0, (unsigned char)(BFLength & 0x7));
}

/**************************************************
 * NAME: PERUpdateBitFieldLength
 *       
 *
 */

static void
PERUpdateBitFieldLength(tCoder* Coder, tPEREncBitField* BitField)
{
  unsigned char Byte;
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERUpdateBitFieldLength\n");
#endif

  if (BitField->CBit == 7)
    {
      Byte = *(Coder->ER.DataEnd + BitField->CByte);
      BitField->CByte++;
    }
  else
    {
      Byte = (unsigned char)(*(Coder->ER.DataEnd + BitField->CByte) << (7 - BitField->CBit));
      BitField->CByte++;
      Byte |= (unsigned char)(*(Coder->ER.DataEnd + BitField->CByte) >> (BitField->CBit + 1));
    }
    
  if (Byte == 0xC4)
    BitField->CLength = 0x10000;
  else
  if (Byte == 0xC3)
    BitField->CLength = 0xC000;
  else
  if (Byte == 0xC2)
    BitField->CLength = 0x8000;
  else
  if (Byte == 0xC1)
    BitField->CLength = 0x4000;
  else
  if((Byte & 0xC0) == 0x80)
    {
      BitField->CLength = ((Byte & 0x7F) << 8);
      if (BitField->CBit == 7)
        {
          Byte = *(Coder->ER.DataEnd + BitField->CByte);
          BitField->CByte++;
        }
      else
        {
          Byte = (unsigned char)(*(Coder->ER.DataEnd + BitField->CByte) << (7 - BitField->CBit));
          BitField->CByte++;
          Byte |= (unsigned char)(*(Coder->ER.DataEnd + BitField->CByte) >> (BitField->CBit + 1));
        }

      BitField->CLength |= Byte;
    }
  else
  if((Byte & 0x80) == 0x00)
    BitField->CLength = (Byte & 0x7F);
  else
    {
      DECODING_ERROR_HANDLER(Coder, return, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
    }
}

/**************************************************
 * NAME: PERGetConsBitField
 *       
 *
 */

static void
PERGetConsBitField(tCoder* Coder, tPERDecBitField* BitField)
{
  unsigned char Byte;
  tVMSULong DecLen;
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERGetConsBitField\n");
#endif

  if (Coder->ER.Rule & er_Aligned)
    PERAlign(Coder);

  BitField->CLength = 0;

  do
    {
      Byte = PERGetByte(Coder);

      if (Byte == 0xC4)
        DecLen = 0x2000;
      else
      if (Byte == 0xC3)
        DecLen = 0x1800;
      else
      if (Byte == 0xC2)
        DecLen = 0x1000;
      else
      if (Byte == 0xC1)
        DecLen = 0x800;
      else
      if((Byte & 0xC0) == 0x80)
        {
          DecLen = (((Byte & 0x7F) << 8) | PERGetByte(Coder));
          if (BitField->CLength == 0)
            {
              BitField->CByte = Coder->ER.DataCurr;
              BitField->CBit = Coder->ER.BitCurr;
              BitField->CLength = DecLen;
            }
          PERGetBits(Coder, (unsigned char)(DecLen & 0x7));
        }
      else
      if((Byte & 0x80) == 0x00)
        {
          DecLen = (Byte & 0x7F);
          if (BitField->CLength == 0)
            {
              BitField->CByte = Coder->ER.DataCurr;
              BitField->CBit = Coder->ER.BitCurr;
              BitField->CLength = DecLen;
            }
          PERGetBits(Coder, (unsigned char)(DecLen & 0x7));
          DecLen >>= 3;
        }
      else
        {
          DECODING_ERROR_HANDLER(Coder, return, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
        }

      if (BitField->CLength == 0)
        {
          BitField->CByte = Coder->ER.DataCurr;
          BitField->CBit = Coder->ER.BitCurr;
          BitField->CLength = (DecLen << 3);
        }
      PERBUF_ERROR_HANDLER_EXP((tVMSULong)(Coder->ER.MemEnd - Coder->ER.DataCurr), DecLen, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
      Coder->ER.DataCurr += DecLen;
    }
  while(DecLen >= 0x800);
}

/**************************************************
 * NAME: PERSetBitFieldLength
 *       
 *
 */

static char
PERSetBitFieldLength(tPERDecBitField* BitField)
{
  unsigned char Byte;
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERGetConsBitField\n");
#endif

  if (BitField->CBit == 7)
    {
      Byte = *(BitField->CByte);
      BitField->CByte++;
    }
  else
    {
      Byte = (unsigned char)(*(BitField->CByte) << (7 - BitField->CBit));
      BitField->CByte++;
      Byte |= (unsigned char)(*(BitField->CByte) >> (BitField->CBit + 1));
    }
    
  if (Byte == 0xC4)
    BitField->CLength = 0x10000;
  else
  if (Byte == 0xC3)
    BitField->CLength = 0xC000;
  else
  if (Byte == 0xC2)
    BitField->CLength = 0x8000;
  else
  if (Byte == 0xC1)
    BitField->CLength = 0x4000;
  else
  if((Byte & 0xC0) == 0x80)
    {
      BitField->CLength = ((Byte & 0x7F) << 8);
      if (BitField->CBit == 7)
        {
          Byte = *(BitField->CByte);
          BitField->CByte++;
        }
      else
        {
          Byte = (unsigned char)(*(BitField->CByte) << (7 - BitField->CBit));
          BitField->CByte++;
          Byte |= (unsigned char)(*(BitField->CByte) >> (BitField->CBit + 1));
        }

      BitField->CLength |= Byte;
      return 0;
    }
  else
    {
      BitField->CLength = (Byte & 0x7F);
      return 0;
    }

  return 1;
}

/**************************************************
 * NAME: PERGetBitFromBitField
 *       
 *
 */

static unsigned char
PERGetBitFromBitField(tPERDecBitField* BitField)
{
  unsigned char Bit = (unsigned char)((*(BitField->CByte) >> BitField->CBit) & 0x1);
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERGetBitFromBitField\n");
#endif

  if (BitField->CBit == 0)
    {
      BitField->CByte++;
      BitField->CBit = 7;
    }
  else
    BitField->CBit--;
  BitField->CLength--;

  return Bit;
}

/**************************************************
 * NAME: PERSetBitToBitField
 *       
 *
 */

static void
PERSetBitToBitField(tCoder* Coder, tPEREncBitField* BitField, unsigned char Bit)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERSetBitToBitField\n");
#endif

  *(Coder->ER.DataEnd + BitField->CByte) |= (unsigned char)(Bit << BitField->CBit);
  if (BitField->CBit == 0)
    {
      BitField->CByte++;
      BitField->CBit = 7;
    }
  else
    BitField->CBit--;
  BitField->CLength--;
 if (BitField->CLength == 0)
   PERUpdateBitFieldLength(Coder, BitField);
}

/**************************************************
 * NAME: PEREncodeStructRoot
 *       
 *
 */

static void
PEREncodeStructRoot(tCoder* Coder, tASN1Struct* Type, void* Val)
{
  tASN1Component* CurrComp;
  CODER_NumOf_TYPE NumOfComps;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeStructRoot\n");
#endif

  if (Type->NumOfRC1 > 0)
    {
      CurrComp = Type->RootComps1;
      NumOfComps = Type->NumOfRC1;

      for (; NumOfComps > 0; NumOfComps--, CurrComp++)
        {
          void* CurrField;

          VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          PEREncVal(Coder, CurrComp->TypeInfo, CurrField);
        }
    }

#ifndef CODER_NOUSE_SEQUENCE
  if (Type->NumOfRC2 > 0)
    {
      CurrComp = Type->RootComps2;
      NumOfComps = Type->NumOfRC2;

      for (; NumOfComps > 0; NumOfComps--, CurrComp++)
        {
          void* CurrField;

          VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          PEREncVal(Coder, CurrComp->TypeInfo, CurrField);
        }
    }
#endif
}

/**************************************************
 * NAME: PERDecodeStructRoot
 *       
 *
 */

static void
PERDecodeStructRoot(tCoder* Coder, tASN1Struct* Type, void* Val, tVMSOpenTypeList* List)
{
  tASN1Component* CurrComp;
  CODER_NumOf_TYPE NumOfComps;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeStructRoot\n");
#endif

  if (Type->NumOfRC1 > 0)
    {
      CurrComp = Type->RootComps1;
      NumOfComps = Type->NumOfRC1;

      for (; NumOfComps > 0; NumOfComps--, CurrComp++)
        {
          void* CurrField;

          VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          PERDecVal(Coder, CurrComp->TypeInfo, CurrField, List);
        }
    }

#ifndef CODER_NOUSE_SEQUENCE
  if (Type->NumOfRC2 > 0)
    {
      CurrComp = Type->RootComps2;
      NumOfComps = Type->NumOfRC2;

      for (; NumOfComps > 0; NumOfComps--, CurrComp++)
        {
          void* CurrField;

          VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          PERDecVal(Coder, CurrComp->TypeInfo, CurrField, List);
        }
    }
#endif
}

/**************************************************
 * NAME: PEREncodeStructRootWithOptDef
 *       
 *
 */

static void
PEREncodeStructRootWithOptDef(tCoder* Coder, tPEREncBitField* BitField, tASN1Struct* Type, void* Val)
{
  tASN1Component* CurrComp;
  CODER_NumOf_TYPE NumOfComps;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeStructRootWithOptDef\n");
#endif

  if (Type->NumOfRC1 > 0)
    {
      CurrComp = Type->RootComps1;
      NumOfComps = Type->NumOfRC1;

      for (; NumOfComps > 0; NumOfComps--, CurrComp++)
        {
          void* CurrField;

          switch (CurrComp->Type)
            {
            case ct_Present:
              PERSetBitToBitField(Coder, BitField, 1);
            case ct_Required:
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              PEREncVal(Coder, CurrComp->TypeInfo, CurrField);
              break;
            case ct_Optional:
              VMSGetOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              if (CurrField != NULL)
                {
                  PERSetBitToBitField(Coder, BitField, 1);
                  PEREncVal(Coder, CurrComp->TypeInfo, CurrField);
                }
              else
                {
                  PERSetBitToBitField(Coder, BitField, 0);
                }
              break;
            case ct_Default:
              VMSGetDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              if (CurrField != NULL)
                {
                  PERSetBitToBitField(Coder, BitField, 1);
                  PEREncVal(Coder, CurrComp->TypeInfo, CurrField);
                }
              else
                {
                  PERSetBitToBitField(Coder, BitField, 0);
                }
              break;
            case ct_Absent:
              PERSetBitToBitField(Coder, BitField, 0);
            default:
              break;
            }
        }
    }

#ifndef CODER_NOUSE_SEQUENCE
  if (Type->NumOfRC2 > 0)
    {
      CurrComp = Type->RootComps2;
      NumOfComps = Type->NumOfRC2;
      for (; NumOfComps > 0; NumOfComps--, CurrComp++)
        {
          void* CurrField;

          switch (CurrComp->Type)
            {
            case ct_Present:
              PERSetBitToBitField(Coder, BitField, 1);
            case ct_Required:
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              PEREncVal(Coder, CurrComp->TypeInfo, CurrField);
              break;
            case ct_Optional:
              VMSGetOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              if (CurrField != NULL)
                {
                  PERSetBitToBitField(Coder, BitField, 1);
                  PEREncVal(Coder, CurrComp->TypeInfo, CurrField);
                }
              else
                {
                  PERSetBitToBitField(Coder, BitField, 0);
                }
              break;
            case ct_Default:
              VMSGetDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              if (CurrField != NULL)
                {
                  PERSetBitToBitField(Coder, BitField, 1);
                  PEREncVal(Coder, CurrComp->TypeInfo, CurrField);
                }
              else
                {
                  PERSetBitToBitField(Coder, BitField, 0);
                }
              break;
            case ct_Absent:
              PERSetBitToBitField(Coder, BitField, 0);
            default:
              break;
            }
        }
    }
#endif
}

/**************************************************
 * NAME: PERDecodeStructRootWithOptDef
 *       
 *
 */

static void
PERDecodeStructRootWithOptDef(tCoder* Coder, tPERDecBitField* BitField, tASN1Struct* Type, void* Val, tVMSOpenTypeList* List)
{
  tASN1Component* CurrComp;
  CODER_NumOf_TYPE NumOfComps;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeStructRootWithOptDef\n");
#endif

  if (Type->NumOfRC1 > 0)
    {
      CurrComp = Type->RootComps1;
      NumOfComps = Type->NumOfRC1;
      for (; NumOfComps > 0; NumOfComps--, CurrComp++)
        {
          void* CurrField;

          switch (CurrComp->Type)
            {
            case ct_Present:
              PERGetBitFromBitField(BitField);
            case ct_Required:
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              PERDecVal(Coder, CurrComp->TypeInfo, CurrField, List);
              break;
            case ct_Optional:
              if (PERGetBitFromBitField(BitField) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  PERDecVal(Coder, CurrComp->TypeInfo, CurrField, List);
                  VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                }
              else
                VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Default:
              if (PERGetBitFromBitField(BitField) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  PERDecVal(Coder, CurrComp->TypeInfo, CurrField, List);
                  VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                }
              else
                VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Absent:
              PERGetBitFromBitField(BitField);
            default:
              break;
            }
          if (BitField->CLength == 0)
            PERSetBitFieldLength(BitField);
        }
    }

#ifndef CODER_NOUSE_SEQUENCE
  if (Type->NumOfRC2 > 0)
    {
      CurrComp = Type->RootComps2;
      NumOfComps = Type->NumOfRC2;
      for (; NumOfComps > 0; NumOfComps--, CurrComp++)
        {
          void* CurrField;

          switch (CurrComp->Type)
            {
            case ct_Present:
              PERGetBitFromBitField(BitField);
            case ct_Required:
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              PERDecVal(Coder, CurrComp->TypeInfo, CurrField, List);
              break;
            case ct_Optional:
              if (PERGetBitFromBitField(BitField) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  PERDecVal(Coder, CurrComp->TypeInfo, CurrField, List);
                  VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
                }
              else
                VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Default:
              if (PERGetBitFromBitField(BitField) == 1)
                {
                  VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
                  PERDecVal(Coder, CurrComp->TypeInfo, CurrField, List);
                  VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
                }
              else
                VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
              break;
            case ct_Absent:
              PERGetBitFromBitField(BitField);
            default:
              break;
            }
          if (BitField->CLength == 0)
            PERSetBitFieldLength(BitField);
        }
    }
#endif
}

#ifndef CODER_NOUSE_EXT
/**************************************************
 * NAME: PEREncodeStructExtGroup
 *       
 *
 */

static unsigned char
PEREncodeStructExtGroup(tCoder* Coder, tASN1Struct* Type, tASN1Component** Current, void* Val)
{
  tPERCurrPos EGStart;
  tPEREncBitField  EGBitField;
  tVMSULong Len;
  CODER_NumOf_TYPE UR, ER, EOD;
  tASN1Component* CurrComp = (*Current) + 1;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeStructExtGroup\n");
#endif
  
  /* Get number of OPTIONAL/DEFAULT component */
  for (Len = 0, EOD = 0; Len < (tVMSULong)(*Current)->Index; Len++, CurrComp++)
    if (CurrComp->Type != ct_Required) 
      EOD++;

  if (Coder->ER.Rule & er_Aligned)
    PERAlign(Coder);

  EGStart.CByte = Coder->ER.DataCurr - Coder->ER.DataEnd;
  EGStart.CBit  = Coder->ER.BitCurr;

  PERSkipBytes(Coder, 1);

  if (EOD < 0x10000)
    PERSkipPrimBitField(Coder, &EGBitField, EOD);
  else
    PERSkipConsBitField(Coder, &EGBitField, EOD);

  UR = ER = EOD = 0;
  for (Len = 0, CurrComp = *Current; Len < (tVMSULong)(*Current)->Index; Len++)
    {
      void* CurrField;
      
      CurrComp++;
      switch (CurrComp->Type)
        {
        case ct_Required:
        case ct_Present:
          VMSGetOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          if (CurrField != NULL)
            {
              PEREncVal(Coder, CurrComp->TypeInfo, CurrField);
              if (CurrComp->Type == ct_Present)
                {
                  PERSetBitToBitField(Coder, (&EGBitField), 1);
                }
              ER++;
            }
          else
            UR++;
          break;
        case ct_Optional:
          VMSGetOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
            if (CurrField != NULL)
              {
                PERSetBitToBitField(Coder, (&EGBitField), 1);
                PEREncVal(Coder, CurrComp->TypeInfo, CurrField);
                EOD++;
              }
            else
              {
                PERSetBitToBitField(Coder, (&EGBitField), 0);
              }
            break;
        case ct_Default:
          VMSGetDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          if (CurrField != NULL)
            {
              PERSetBitToBitField(Coder, (&EGBitField), 1);
              PEREncVal(Coder, CurrComp->TypeInfo, CurrField);
              EOD++;
            }
          else
            {
              PERSetBitToBitField(Coder, (&EGBitField), 0);
            }
          break;
        case ct_Absent:
          PERSetBitToBitField(Coder, (&EGBitField), 0);
          break;
        default:
          INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
          break;
        }
    }
  
  if ((UR != 0) && (EOD != 0))
    DECODING_ERROR_HANDLER(Coder, return 0, ec_DEC_ExtRequiredComponentIsAbsent, NO_ARGS);

  *Current = CurrComp;

  if ((ER > 0) || (EOD > 0))
    {
      Len = (Coder->ER.DataCurr - Coder->ER.DataEnd) - (EGStart.CByte + 1);

      if (EGStart.CBit > Coder->ER.BitCurr)
        {
          PERPutBits(Coder, 0, (unsigned char)(8 - (EGStart.CBit - Coder->ER.BitCurr)));
          Len += 1;
        }
      else
      if (Len > 0)
        PERPutBits(Coder, 0, (unsigned char)(Coder->ER.BitCurr - EGStart.CBit));
      
      if (Len == 0)
        {
          Coder->ER.DataCurr--;
          PERPutBits(Coder, 0x0100, 16);
        }
      else
      if (Len <= 0x7F)
        {
          unsigned char* CurrByte = Coder->ER.DataEnd + EGStart.CByte;

          if (Coder->ER.BitCurr != 7)
            {
              *CurrByte |= (unsigned char)(Len >> (7 - Coder->ER.BitCurr));
              CurrByte++;
              *CurrByte |= (unsigned char)(Len << (Coder->ER.BitCurr + 1));
            }
          else
            *CurrByte = (unsigned char)Len;
        }
      else
        {
          if (Coder->ER.BitCurr == 7)
            PEROctetsFragmentation(Coder, Len);
          else
            PEROctetsFragmentationWithOffset(Coder, Len);
        }

      return 1;
    }

  Coder->ER.DataCurr = Coder->ER.DataEnd + EGStart.CByte;
  Coder->ER.BitCurr = EGStart.CBit;
  *(Coder->ER.DataCurr) &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
  
  return 0;
}

/**************************************************
 * NAME: PERInitAbsentStructExtGroup
 *       
 *
 */

static void
PERInitAbsentStructExtGroup(tCoder* Coder, tASN1Struct* Type, tASN1Component** Current, void* Val)
{
  tASN1Component* CurrComp = *Current;
  CODER_NumOf_TYPE NumOfComps = (*Current)->Index;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERInitAbsentStructExtGroup\n");
#endif

  while (NumOfComps > 0)
    {         
      CurrComp++;
      switch (CurrComp->Type)
        {
        case ct_Required:
        case ct_Present:
        case ct_Optional:
          VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
          break;
        case ct_Default:
          VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
          break;
        case ct_Absent:
          break;
        default:
          INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
        }
      NumOfComps--;
    }

  *Current = CurrComp;
}

/**************************************************
 * NAME: PERDecodeStructExtGroup
 *       
 *
 */

static void
PERDecodeStructExtGroup(tCoder* Coder, tASN1Struct* Type, tASN1Component** Current, void* Val, tVMSOpenTypeList* List)
{
  CODER_NumOf_TYPE NOOD, i;
  tVMSULong Length;
  tASN1Component* CurrComp = (*Current) + 1;
  tPERDecBitField EGBitField;
  unsigned char EncBit, *EncByte = NULL;
  char Offset = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeStructExtGroup\n");
#endif

  /* Get number of OPTIONAL/DEFAULT component */
  for (i = (*Current)->Index, NOOD = 0; i > 0; i--, CurrComp++)
    if (CurrComp->Type != ct_Required) 
      NOOD++;

  if (Coder->ER.Rule & er_Aligned)
    PERAlign(Coder);

  EncBit = PERGetByte(Coder);

  if (EncBit >= 0xC1)
    {
      Coder->ER.DataCurr--;
      if (Coder->ER.BitCurr != 7)
        {
          Length = PEROctetsDefragmentationWithOffset(Coder);
          Offset = 1;
        }
      else
        {
          Length = PEROctetsDefragmentation(Coder);
          Offset = -1;
        }
    }
  else
  if((EncBit & 0xC0) == 0x80)
    {
      Length = (((EncBit & 0x7F) << 8) | PERGetByte(Coder));
      EncByte = Coder->ER.DataCurr + Length;
      EncBit = Coder->ER.BitCurr;
    }
  else
  if((EncBit & 0x80) == 0x00)
    {
      Length = (EncBit & 0x7F);
      EncByte = Coder->ER.DataCurr + Length;
      EncBit = Coder->ER.BitCurr;
    }
  else
    {
      DECODING_ERROR_HANDLER(Coder, return, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
    }

  if (NOOD < 0x10000)
    PERGetPrimBitField(Coder, &EGBitField, NOOD);
  else
    PERGetConsBitField(Coder, &EGBitField);

  for (i = (*Current)->Index, CurrComp = *Current; i > 0; i--)
    {
      void* CurrField;
      
      CurrComp++;
      switch (CurrComp->Type)
        {
        case ct_Present:
          PERGetBitFromBitField(&EGBitField);
        case ct_Required:
          VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          PERDecVal(Coder, CurrComp->TypeInfo, CurrField, List);
          VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
          break;
        case ct_Optional:
          if (PERGetBitFromBitField(&EGBitField) == 1)
            {
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              PERDecVal(Coder, CurrComp->TypeInfo, CurrField, List);
              VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
            }
          else
            VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
          break;
        case ct_Default:
          if (PERGetBitFromBitField(&EGBitField) == 1)
            {
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              PERDecVal(Coder, CurrComp->TypeInfo, CurrField, List);
              VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
            }
          else
            VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
          break;
        case ct_Absent:
          PERGetBitFromBitField(&EGBitField);
        default:
          break;
        }
      if (EGBitField.CLength == 0)
        PERSetBitFieldLength(&EGBitField);
    }

  if (Offset == 1)
    PEROctetsFragmentationWithOffset(Coder, Length);
  else
  if (Offset == -1)
    PEROctetsFragmentation(Coder, Length);
  else
    {
      Coder->ER.DataCurr = EncByte;
      Coder->ER.BitCurr = EncBit;
    }

  *Current = CurrComp;
}

/**************************************************
 * NAME: PEREncodeStructExtAdd
 *       
 *
 */

static unsigned char
PEREncodeStructExtAdd(tCoder* Coder, tPEREncBitField* BitField, tASN1Struct* Type, void* Val)
{
  tASN1Component* CurrComp = Type->ExtAddComps;
  CODER_NumOf_TYPE /*UR,*/ ER, EOD, NumOfComps = Type->NumOfEAC;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeStructExtAdd\n");
#endif

  /*UR =*/ ER = EOD = 0;

  while (NumOfComps > 0)
    {
      void* CurrField;
      
      switch (CurrComp->Type)
        {
        case ct_Required:
        case ct_Present:
          VMSGetOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          if (CurrField != NULL)
            {
              PERSetBitToBitField(Coder, BitField, 1);
              PEREncodeOPENTypeField(Coder, CurrComp->TypeInfo, CurrField);
              ER++;
            }
          else
            {
              PERSetBitToBitField(Coder, BitField, 0);
              /*UR++;*/
            }
          break;
        case ct_Optional:
          VMSGetOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          if (CurrField != NULL)
            {
              PERSetBitToBitField(Coder, BitField, 1);
              PEREncodeOPENTypeField(Coder, CurrComp->TypeInfo, CurrField);
              EOD++;
            }
          else
            {
              PERSetBitToBitField(Coder, BitField, 0);
            }
          break;
        case ct_Default:
          VMSGetDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
          if (CurrField != NULL)
            {
              PERSetBitToBitField(Coder, BitField, 1);
              PEREncodeOPENTypeField(Coder, CurrComp->TypeInfo, CurrField);
              EOD++;
            }
          else
            {
              PERSetBitToBitField(Coder, BitField, 0);
            }
          break;
        case ct_Absent:
          PERSetBitToBitField(Coder, BitField, 0);
          break;
        case ct_Group:
          NumOfComps = (CODER_NumOf_TYPE)(NumOfComps - CurrComp->Index);
          if (PEREncodeStructExtGroup(Coder, Type, &CurrComp, Val) == 1)
            {
              PERSetBitToBitField(Coder, BitField, 1);
              EOD++;
            }
          else
            {
              PERSetBitToBitField(Coder, BitField, 0);
            }
          break;
        default:
          INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
        }
      CurrComp++;
      NumOfComps--;
    } 

  /* Wrong error code!!! */
  /*  if ((UR != 0) && (EOD != 0))
      DECODING_ERROR_HANDLER(Coder, return, ec_DEC_ExtRequiredComponentIsAbsent, NO_ARGS);*/

  if ((ER > 0) || (EOD > 0))
    return 1;

  return 0;
}

/**************************************************
 * NAME: PERDecodeStructExtAdd
 *       
 *
 */

static void
PERDecodeStructExtAdd(tCoder* Coder, tPERDecBitField* BitField, tASN1Struct* Type, void* Val, tVMSOpenTypeList* List)
{
  tASN1Component* CurrComp = Type->ExtAddComps;
  CODER_NumOf_TYPE UR, DOD, NumOfComps = Type->NumOfEAC;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeStructExtAdd\n");
#endif

  UR = DOD = 0;

  while (NumOfComps > 0)
    {
      void* CurrField;

      switch (CurrComp->Type)
        {
        case ct_Required:
        case ct_Present:
          if (PERGetBitFromBitField(BitField) == 1)
            {
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              PERDecodeOPENTypeField(Coder, CurrComp->TypeInfo, CurrField, List);
              VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
            }
          else
            {
              VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
              UR++;
            }
          break;
        case ct_Optional:
          if (PERGetBitFromBitField(BitField) == 1)
            {
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              PERDecodeOPENTypeField(Coder, CurrComp->TypeInfo, CurrField, List);
              VMSInitPresentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
              DOD++;
            }
          else
            VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
          break;
        case ct_Default:
          if (PERGetBitFromBitField(BitField) == 1)
            {
              VMSGetComponentSEQUENCE(Coder, Val, Type, CurrComp, CurrField);
              PERDecodeOPENTypeField(Coder, CurrComp->TypeInfo, CurrField, List);
              VMSInitPresentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
              DOD++;
            }
          else
            VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
          break;
        case ct_Absent:
          PERGetBitFromBitField(BitField);
          break;
        case ct_Group:
          NumOfComps = (CODER_NumOf_TYPE)(NumOfComps - CurrComp->Index);
          if (PERGetBitFromBitField(BitField) == 1)
            {
              PERDecodeStructExtGroup(Coder, Type, &CurrComp, Val, List);
              DOD++;              
            }
          else
            PERInitAbsentStructExtGroup(Coder, Type, &CurrComp, Val);
          break;
        default:
          INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
        }
      if (BitField->CLength == 0)
        PERSetBitFieldLength(BitField);
      CurrComp++;
      NumOfComps--;
    }

  if ((UR != 0) && (DOD != 0))
    DECODING_ERROR_HANDLER(Coder, return, ec_DEC_ExtRequiredComponentIsAbsent, NO_ARGS);
}
#endif /* CODER_NOUSE_EXT */


/**************************************************
 * NAME: PERInitAbsentStructExtAdd
 *       
 *
 */

static void
PERInitAbsentStructExtAdd(tCoder* Coder, tASN1Struct* Type, void* Val)
{
  tASN1Component* CurrComp = Type->ExtAddComps;
  CODER_NumOf_TYPE NumOfComps = Type->NumOfEAC;
  
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERInitAbsentStructExtAdd\n");
#endif

  for (; NumOfComps > 0; NumOfComps--, CurrComp++)
    {     
      switch (CurrComp->Type)
        {
        case ct_Required:
        case ct_Present:
        case ct_Optional:
          VMSInitAbsentOptionalComponentSEQUENCE(Coder, Val, Type, CurrComp);
          break;
        case ct_Default:
          VMSInitAbsentDefaultComponentSEQUENCE(Coder, Val, Type, CurrComp);
          break;
        case ct_Group:
        case ct_Absent:
          break;
        default:
          INTERNAL_ERROR_HANDLER(Coder, break, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
        }
    }
}

/**************************************************
 * NAME: PERSkipExtAddition
 *       
 *
 */

static void
PERSkipExtAddition(tCoder* Coder)
{
  tPERDecBitField EABitField;
  unsigned char Constr = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERSkipExtAddition\n");
#endif

  if (PERGetBit(Coder) == 1)
    {
      PERGetConsBitField(Coder, &EABitField);
      Constr = 1;
    }
  else
    {
      tVMSULong Length;
      PERDecodeNonNegativeBinaryINTEGER(Coder, 6, Length);
      PERGetPrimBitField(Coder, &EABitField, Length + 1);
      EABitField.CLength--;
    }
  
  for (;(EABitField.CLength == 0) && (Constr == 0);)
    {      
      if (PERGetBitFromBitField(&EABitField) == 1)
        PERSkipOPENTypeField(Coder);

      if ((EABitField.CLength == 0) && (Constr == 1))
        Constr = PERSetBitFieldLength(&EABitField);
    }
}

/**************************************************
 * NAME: PEREncodeStruct
 *       
 *
 */

static void
PEREncodeStruct(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeStruct\n");
#endif

  if (((tASN1Struct*)Type)->RootExtFlags & 0x01)
    {
#ifndef CODER_NOUSE_EXT
      tPERCurrPos EAPresent;

      EAPresent.CByte = Coder->ER.DataCurr - Coder->ER.DataEnd;
      EAPresent.CBit = Coder->ER.BitCurr;
#endif
      PERPutBit(Coder, 0); /* Skip 1 bit */

      if (((tASN1Struct*)Type)->NumOfOptDef > 0)
        {
          tPEREncBitField ODBitField;

          if (((tASN1Struct*)Type)->NumOfOptDef < 0x10000)
            PERSkipPrimBitField(Coder, &ODBitField, ((tASN1Struct*)Type)->NumOfOptDef);
          else
            PERSkipConsBitField(Coder, &ODBitField, ((tASN1Struct*)Type)->NumOfOptDef);

          PEREncodeStructRootWithOptDef(Coder, &ODBitField, (tASN1Struct*)Type, Val);
        }
      else
        PEREncodeStructRoot(Coder, (tASN1Struct*)Type, Val);

#ifndef CODER_NOUSE_EXT
      if (((tASN1Struct*)Type)->NumOfExtAdd > 0)
        {
          tPERCurrPos EAStart;
          tPEREncBitField EABitField;

          EAStart.CByte = Coder->ER.DataCurr - Coder->ER.DataEnd;
          EAStart.CBit = Coder->ER.BitCurr;

          if (((tASN1Struct*)Type)->NumOfExtAdd <= 0x40)
            {
              PEREncodeNonNegativeBinaryINTEGER(Coder, ((tASN1Struct*)Type)->NumOfExtAdd - 1, 7);
              PERSkipPrimBitField(Coder, &EABitField, ((tASN1Struct*)Type)->NumOfExtAdd);
            }
          else
            {
              PERPutBit(Coder, 1);
              PERSkipConsBitField(Coder, &EABitField, ((tASN1Struct*)Type)->NumOfExtAdd);
            }

          if (PEREncodeStructExtAdd(Coder, &EABitField, (tASN1Struct*)Type, Val) == 1)
            *(Coder->ER.DataEnd + EAPresent.CByte) |= (unsigned char)(1 << EAPresent.CBit);
          else
            {
              Coder->ER.DataCurr = Coder->ER.DataEnd + EAStart.CByte;
              Coder->ER.BitCurr = EAStart.CBit;
              *(Coder->ER.DataCurr) &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
            }
        }
#endif
    }
  else
  if (((tASN1Struct*)Type)->NumOfOptDef > 0)
    {
      tPEREncBitField ODBitField;
      
      if (((tASN1Struct*)Type)->NumOfOptDef < 0x10000)
        PERSkipPrimBitField(Coder, &ODBitField, ((tASN1Struct*)Type)->NumOfOptDef);
      else
        PERSkipConsBitField(Coder, &ODBitField, ((tASN1Struct*)Type)->NumOfOptDef);
      
      PEREncodeStructRootWithOptDef(Coder, &ODBitField, (tASN1Struct*)Type, Val);
    }
  else
    PEREncodeStructRoot(Coder, (tASN1Struct*)Type, Val);
}

/**************************************************
 * NAME: PERDecodeStruct
 *       
 *
 */

static void
PERDecodeStruct(tCoder* Coder, tASN1TypeInfo* Type, void* Val, tVMSOpenTypeList* List)
{
  unsigned char ExtAddPresent = 0;    /* Flag: 1 if ext.add. present, 0 - in other case */
  tVMSOpenTypeList LList, *LListPtr = List;
  
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeStruct\n");
#endif

#ifndef CODER_NOUSE_OPEN  
  if (((tASN1Struct*)Type)->RootExtFlags & 0x10)
    {
      LListPtr = &LList;

      LList.Bodies = NULL;
      if (List != NULL)
        LList.Ids = List->Ids;
      else
        LList.Ids = NULL;
    }
#endif

  if (((tASN1Struct*)Type)->RootExtFlags & 0x01)
    ExtAddPresent = PERGetBit(Coder);

  /* Decoding "ROOT" components */
  if (((tASN1Struct*)Type)->NumOfOptDef > 0)
    {
      tPERDecBitField ODBitField;

      if (((tASN1Struct*)Type)->NumOfOptDef < 0x10000)
        PERGetPrimBitField(Coder, &ODBitField, ((tASN1Struct*)Type)->NumOfOptDef);
      else
        PERGetConsBitField(Coder, &ODBitField);
     
      PERDecodeStructRootWithOptDef(Coder, &ODBitField, (tASN1Struct*)Type, Val, LListPtr);
    }
  else
    PERDecodeStructRoot(Coder, (tASN1Struct*)Type, Val, LListPtr);

  /* Decoding "Ext. Add" components */
  if (ExtAddPresent == 1)
#ifndef CODER_NOUSE_EXT
    {
      if (((tASN1Struct*)Type)->NumOfExtAdd > 0)
        {
          tPERDecBitField EABitField;

          if (PERGetBit(Coder) == 1)
            PERGetConsBitField(Coder, &EABitField);
          else
            {
              tVMSULong Length;

              PERDecodeNonNegativeBinaryINTEGER(Coder, 6, Length);
              PERGetPrimBitField(Coder, &EABitField, Length + 1);
            }

          PERDecodeStructExtAdd(Coder, &EABitField, (tASN1Struct*)Type, Val, LListPtr);
        }
      else
#endif
        PERSkipExtAddition(Coder);
#ifndef CODER_NOUSE_EXT
    }
  else
#endif
  if (((tASN1Struct*)Type)->RootExtFlags & 0x01)
    PERInitAbsentStructExtAdd(Coder, (tASN1Struct*)Type, Val);

#ifndef CODER_NOUSE_OPEN
  if (((tASN1Struct*)Type)->RootExtFlags & 0x10)
    {
      if (LList.Bodies != NULL)
        PERDecodeSkipedValues(Coder, &LList);

      if (List != NULL)
        {
          if (LList.Bodies != NULL)
            {
              if (List->Bodies != NULL)
                {
                  tVMSOpenBodyList* LastBody = List->Bodies;

                  while (LastBody->Next != NULL)
                    LastBody = LastBody->Next;

                  LastBody->Next = LList.Bodies;
                }
              else
                List->Bodies = LList.Bodies;
            }
          
          if (List->Ids == NULL)
            List->Ids = LList.Ids;
        }
      else
        {
          DECODING_ERROR_HANDLER_EXP((LList.Bodies != NULL), Coder, return, ec_DEC_NoOpenId, NO_ARGS);

          while (LList.Ids != NULL)
            {
              tVMSOpenIdList* CurrId = LList.Ids;
              LList.Ids = CurrId->Next;

              CUCFFree(Coder, CurrId, sizeof(tVMSOpenBodyList), 0);
            }
        }
    }
#endif
}

#endif /* !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET) */


#ifndef CODER_NOUSE_SEQUENCE_OF
/*************************************************/
/***************** SEQUENCE OF *******************/
/*************************************************/

/**************************************************
 * NAME: PEREncodePrimSEQUENCE_OF
 *       
 *
 */

static void
PEREncodePrimSEQUENCE_OF(tCoder* Coder, tVMSULong Length, tPERStructOfInfo* Info)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodePrimSEQUENCE_OF\n");
#endif

  while (Info->Length > 0)
    {
      void* CurrElem = NULL;
      
      VMSGetComponentSEQUENCE_OF(Coder, (Info->Value), (Info->Type), (Info->CurrElem), CurrElem);

      PEREncVal(Coder, Info->Type->BaseType, CurrElem);
      Info->CurrElem++;
      Info->Length--;
    }
}

/**************************************************
 * NAME: PERDecodePrimSEQUENCE_OF
 *       
 *
 */

static void
PERDecodePrimSEQUENCE_OF(tCoder* Coder, tVMSULong Length, tPERStructOfInfo* Info)
{
  tVMSULong CurrLength = Length;
  tVMSULong Index = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodePrimSEQUENCE_OF\n");
#endif

#ifndef CODER_NOUSE_OPEN
  if (Info->List != NULL)
    {
      tVMSOpenTypeList LList;

      LList.Bodies = NULL;
      LList.Ids = Info->List->Ids;

      while (CurrLength > 0)
        {
          void* CurrElem = NULL;
          
          VMSInitComponentSEQUENCE_OF(Coder, (Info->Value), (Info->Type), Index, CurrElem);
          
          PERDecVal(Coder, Info->Type->BaseType, CurrElem, &LList);
          VMSSetComponentSEQUENCE_OF(Coder, (Info->Value), (Info->Type), Index, CurrElem);          

          while (LList.Ids != Info->List->Ids)
            {
              tVMSOpenIdList* CurrId = LList.Ids;
              
              LList.Ids = CurrId->Next;
              CUCFFree(Coder, CurrId, sizeof(tVMSOpenIdList), 0);
            }
          
          CurrLength--;
          Index++;
        }

      if (LList.Bodies != NULL)
        {
          if (Info->List->Bodies != NULL)
            {
              tVMSOpenBodyList* LastBody = Info->List->Bodies;
              
              while (LastBody->Next != NULL)
                LastBody = LastBody->Next;
              
              LastBody->Next = LList.Bodies;
            }
          else
            Info->List->Bodies = LList.Bodies;
        }
    }
  else
#endif
    {
      while (CurrLength > 0)
        {
          void* CurrElem = NULL;
          
          VMSInitComponentSEQUENCE_OF(Coder, (Info->Value), (Info->Type), Index, CurrElem);
          
          PERDecVal(Coder, Info->Type->BaseType, CurrElem, NULL);
                
          VMSSetComponentSEQUENCE_OF(Coder, (Info->Value), (Info->Type), Index, CurrElem);
          
          CurrLength--;
          Index++;
        }
    }

  Info->Length += Length;
}

/**************************************************
 * NAME: PEREncodeConsSEQUENCE_OF
 *       
 *
 */

#define PEREncodeConsSEQUENCE_OF(Coder, Info) PERConstructedEncode(Coder, (tPERConstructedInfo*)Info)

/**************************************************
 * NAME: PERDecodeConsSEQUENCE_OF
 *       
 *
 */

#define PERDecodeConsSEQUENCE_OF(Coder, Info) PERConstructedDecode(Coder, (tPERConstructedInfo*)Info)

/*************************************************/

/* Low bound of constraint */
#define PERSeqOfLBound(iType) ((tASN1StructOf*)iType)->SizeConstraint.LBound
/* Up bound of constraint */
#define PERSeqOfUBound(iType) (((tASN1StructOf*)iType)->SizeConstraint.pUBound)
/* Extension marker */
#define PERSeqOfExtMarker(iType) ((tASN1StructOf*)iType)->SizeConstraint.ExtMarker

/**************************************************
 * NAME: PEREncodeSEQUENCE_OF
 *       
 *
 */

static void
PEREncodeSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* vSeqOf)
{
  tVMSULong SeqOfSize = 0;
  tPERStructOfInfo StructOfInfo;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeSEQUENCE_OF\n");
#endif

  VALUE_ERROR_HANDLER_EXP((Coder->EMS.ErrorCode =
                          CUCFCheckSEQUENCE_OF(Coder, Type, vSeqOf)) != ec_SUCCESS,
                          Coder,
                          return,
                          Coder->EMS.ErrorCode,
                          ERR_ARG("SEQUENCE OF"));

  VMSGetSizeSEQUENCE_OF(Coder, vSeqOf, Type, SeqOfSize);

  StructOfInfo.Length = SeqOfSize;
  StructOfInfo.Value = vSeqOf;
  StructOfInfo.CurrElem = 0;
  StructOfInfo.Type = (tASN1StructOf*)Type;
  StructOfInfo.PrimOp = (tPERStructOfFunc)PEREncodePrimSEQUENCE_OF;
  
  if (PERSeqOfExtMarker(Type) == em_Present)
    {
      if ((SeqOfSize < (tVMSULong)PERSeqOfLBound(Type)) || 
          ((((tASN1StructOf*)Type)->ConstraintMask) && (SeqOfSize > (tVMSULong)PERSeqOfUBound(Type))))
        {
          PERPutBit(Coder, 1);
          PEREncodeConsSEQUENCE_OF(Coder, &StructOfInfo);
          return;
        }
      else
        PERPutBit(Coder, 0);
    }

  if (((tASN1StructOf*)Type)->ConstraintMask)
    {
      if (PERSeqOfLBound(Type) == PERSeqOfUBound(Type))
        {
          if (PERSeqOfLBound(Type) == 0) { /* Nothing */ }
          else
          if (PERSeqOfLBound(Type) < 0x10000)
            PEREncodePrimSEQUENCE_OF(Coder, PERSeqOfLBound(Type), &StructOfInfo);
          else
            PEREncodeConsSEQUENCE_OF(Coder, &StructOfInfo);          
        }
      else
        {
          if (PERSeqOfUBound(Type) < 0x10000)
            {
              PEREncodeConstrainedWholeNumber(Coder, PERSeqOfLBound(Type), PERSeqOfUBound(Type), SeqOfSize);
              PEREncodePrimSEQUENCE_OF(Coder, SeqOfSize, &StructOfInfo);
            }
          else
            PEREncodeConsSEQUENCE_OF(Coder, &StructOfInfo);
        }
    }
  else
    PEREncodeConsSEQUENCE_OF(Coder, &StructOfInfo);
}

/**************************************************
 * NAME: PERDecodeSEQUENCE_OF
 *       
 *
 */

static void
PERDecodeSEQUENCE_OF(tCoder* Coder, tASN1TypeInfo* Type, void* vSeqOf, tVMSOpenTypeList* List)
{
  tPERStructOfInfo StructOfInfo;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeSEQUENCE_OF\n");
#endif

  VMSInitSEQUENCE_OF(Coder, vSeqOf, Type);
    
  /* Init StructOf */
  StructOfInfo.Value = vSeqOf;
  StructOfInfo.Length = 0;
  StructOfInfo.List = List;
  StructOfInfo.Type = (tASN1StructOf*)Type;
  StructOfInfo.PrimOp = (tPERStructOfFunc)PERDecodePrimSEQUENCE_OF;

  if((PERSeqOfExtMarker(Type) == em_Present) && (PERGetBit(Coder) == 1))
    PERDecodeConsSEQUENCE_OF(Coder, &StructOfInfo);
  else
  if (((tASN1StructOf*)Type)->ConstraintMask)
    {
      if (PERSeqOfLBound(Type) == PERSeqOfUBound(Type))
        {
          if (PERSeqOfLBound(Type) == 0) { /* Nothing */ }
          else
          if (PERSeqOfLBound(Type) < 0x10000)
            PERDecodePrimSEQUENCE_OF(Coder, PERSeqOfLBound(Type), &StructOfInfo);
          else
            PERDecodeConsSEQUENCE_OF(Coder, &StructOfInfo);          
        }
      else
        {
          if (PERSeqOfUBound(Type) < 0x10000)
            {
              tVMSULong Length;
              
              PERDecodeConstrainedWholeNumber(Coder, PERSeqOfLBound(Type), PERSeqOfUBound(Type), (tVMSInteger*)&Length);
              PERDecodePrimSEQUENCE_OF(Coder, Length, &StructOfInfo);
            }
          else
            PERDecodeConsSEQUENCE_OF(Coder, &StructOfInfo);
        }
    }
  else
    PERDecodeConsSEQUENCE_OF(Coder, &StructOfInfo);

  VALUE_ERROR_HANDLER_EXP((Coder->EMS.ErrorCode =
                          CUCFCheckSEQUENCE_OF(Coder, Type, vSeqOf)) != ec_SUCCESS,
                          Coder,
                          return,
                          Coder->EMS.ErrorCode,
                          ERR_ARG("SEQUENCE OF"));

}
#endif /* CODER_NOUSE_SEQUENCE_OF */


#ifndef CODER_NOUSE_SET_OF
/*************************************************/
/******************* SET OF **********************/
/*************************************************/

/**************************************************
 * NAME: PEREncodePrimSET_OF
 *       
 *
 */

static void
PEREncodePrimSET_OF(tCoder* Coder, tVMSULong Length, tPERStructOfInfo* Info)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodePrimSET_OF\n");
#endif

  while (Info->Length > 0)
    {
      void* CurrElem = NULL;
      
      VMSGetComponentSET_OF(Coder, (Info->Value), (Info->Type), (Info->CurrElem), CurrElem);

      PEREncVal(Coder, Info->Type->BaseType, CurrElem);
      Info->CurrElem++;
      Info->Length--;
    }
}

/**************************************************
 * NAME: PERDecodePrimSET_OF
 *       
 *
 */

static void
PERDecodePrimSET_OF(tCoder* Coder, tVMSULong Length, tPERStructOfInfo* Info)
{
  tVMSULong CurrLength = Length;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodePrimSET_OF\n");
#endif

#ifndef CODER_NOUSE_OPEN
  if (Info->List != NULL)
    {
      tVMSOpenTypeList LList;
      
      LList.Bodies = NULL;
      LList.Ids = Info->List->Ids;

      while (CurrLength > 0)
        {
          void* CurrElem;
          
          VMSInitComponentSET_OF(Coder, (Info->Value), (Info->Type), CurrElem);
          
          PERDecVal(Coder, Info->Type->BaseType, CurrElem, &LList);
          VMSSetComponentSET_OF(Coder, (Info->Value), (Info->Type), CurrElem);
          
          while (LList.Ids != Info->List->Ids)
            {
              tVMSOpenIdList* CurrId = LList.Ids;
              
              LList.Ids = CurrId->Next;
              CUCFFree(Coder, CurrId, sizeof(tVMSOpenIdList), 0);
            }
          
          CurrLength--;
        }

      if (LList.Bodies != NULL)
        {
          if (Info->List->Bodies != NULL)
            {
              tVMSOpenBodyList* LastBody = Info->List->Bodies;
              
              while (LastBody->Next != NULL)
                LastBody = LastBody->Next;
              
              LastBody->Next = LList.Bodies;
            }
          else
            Info->List->Bodies = LList.Bodies;
        }
    }
  else
#endif
    {
      while (CurrLength > 0)
        {
          void* CurrElem;
          
          VMSInitComponentSET_OF(Coder, (Info->Value), (Info->Type), CurrElem);
          
          PERDecVal(Coder, Info->Type->BaseType, CurrElem, NULL);
          
          VMSSetComponentSET_OF(Coder, (Info->Value), (Info->Type), CurrElem);
          
          CurrLength--;
        }
    }

  Info->Length += Length;
}

/**************************************************
 * NAME: PEREncodeConsSET_OF
 *       
 *
 */

#define PEREncodeConsSET_OF(Coder, Info) PERConstructedEncode(Coder, (tPERConstructedInfo*)Info)

/**************************************************
 * NAME: PERDecodeConsSET_OF
 *       
 *
 */

#define PERDecodeConsSET_OF(Coder, Info) PERConstructedDecode(Coder, (tPERConstructedInfo*)Info)

/*************************************************/

/* Low bound of constraint */
#define PERSetOfLBound(iType) ((tASN1StructOf*)iType)->SizeConstraint.LBound
/* Up bound of constraint */
#define PERSetOfUBound(iType) (((tASN1StructOf*)iType)->SizeConstraint.pUBound)
/* Extension marker */
#define PERSetOfExtMarker(iType) ((tASN1StructOf*)iType)->SizeConstraint.ExtMarker

/**************************************************
 * NAME: PEREncodeSET_OF
 *       
 *
 */

static void
PEREncodeSET_OF(tCoder* Coder, tASN1TypeInfo* Type, void* vSetOf)
{
  tVMSULong SetOfSize;
  tPERStructOfInfo StructOfInfo;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeSET_OF\n");
#endif

  VALUE_ERROR_HANDLER_EXP((Coder->EMS.ErrorCode =
                          CUCFCheckSET_OF(Coder, Type, vSetOf)) != ec_SUCCESS,
                          Coder,
                          return,
                          Coder->EMS.ErrorCode,
                          ERR_ARG("SET OF"));

  VMSGetSizeSET_OF(Coder, vSetOf, Type, SetOfSize);

  StructOfInfo.Length = SetOfSize;
  StructOfInfo.Value = vSetOf;
  StructOfInfo.CurrElem = 0;
  StructOfInfo.Type = (tASN1StructOf*)Type;
  StructOfInfo.PrimOp = (tPERStructOfFunc)PEREncodePrimSET_OF;
  
  if (PERSetOfExtMarker(Type) == em_Present)
    {
      if ((SetOfSize < (tVMSULong)PERSetOfLBound(Type)) || 
          ((((tASN1StructOf*)Type)->ConstraintMask) && (SetOfSize > (tVMSULong)PERSetOfUBound(Type))))
        {
          PERPutBit(Coder, 1);
          PEREncodeConsSET_OF(Coder, &StructOfInfo);
          return;
        }
      else
        PERPutBit(Coder, 0);
    }

  if (((tASN1StructOf*)Type)->ConstraintMask)
    {
      if (PERSetOfLBound(Type) == PERSetOfUBound(Type))
        {
          if (PERSetOfLBound(Type) == 0)
            {
              /* Nothing */
            }
          else
          if (PERSetOfLBound(Type) < 0x10000)
            PEREncodePrimSET_OF(Coder, PERSetOfLBound(Type), &StructOfInfo);
          else
            PEREncodeConsSET_OF(Coder, &StructOfInfo);          
        }
      else
        {
          if (PERSetOfUBound(Type) < 0x10000)
            {
              PEREncodeConstrainedWholeNumber(Coder, PERSetOfLBound(Type), PERSetOfUBound(Type), SetOfSize);
              PEREncodePrimSET_OF(Coder, SetOfSize, &StructOfInfo);
            }
          else
            PEREncodeConsSET_OF(Coder, &StructOfInfo);
        }
    }
  else
    PEREncodeConsSET_OF(Coder, &StructOfInfo);
}

/**************************************************
 * NAME: PERDecodeSET
 *       
 *
 */

static void
PERDecodeSET_OF(tCoder* Coder, tASN1TypeInfo* Type, void* vSetOf, tVMSOpenTypeList* List)
{
  tPERStructOfInfo StructOfInfo;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeSET_OF\n");
#endif

  VMSInitSET_OF(Coder, vSetOf, Type);
    
  /* Init StructOf */
  StructOfInfo.Value = vSetOf;
  StructOfInfo.Length = 0;
  StructOfInfo.List = List;
  StructOfInfo.Type = (tASN1StructOf*)Type;
  StructOfInfo.PrimOp = (tPERStructOfFunc)PERDecodePrimSET_OF;

  if((PERSetOfExtMarker(Type) == em_Present) && (PERGetBit(Coder) == 1))
    PERDecodeConsSET_OF(Coder, &StructOfInfo);
  else
  if (((tASN1StructOf*)Type)->ConstraintMask)
    {
      if (PERSetOfLBound(Type) == PERSetOfUBound(Type))
        {
          if (PERSetOfLBound(Type) == 0) { /* Nothing */ }
          else
          if (PERSetOfLBound(Type) < 0x10000)
            PERDecodePrimSET_OF(Coder, PERSetOfLBound(Type), &StructOfInfo);
          else
            PERDecodeConsSET_OF(Coder, &StructOfInfo);          
        }
      else
        {
          if (PERSetOfUBound(Type) < 0x10000)
            {
              tVMSULong Length;
              
              PERDecodeConstrainedWholeNumber(Coder, PERSetOfLBound(Type), PERSetOfUBound(Type), (tVMSInteger*)&Length);
              PERDecodePrimSET_OF(Coder, Length, &StructOfInfo);
            }
          else
            PERDecodeConsSET_OF(Coder, &StructOfInfo);
        }
    }
  else
    PERDecodeConsSET_OF(Coder, &StructOfInfo);


  VALUE_ERROR_HANDLER_EXP((Coder->EMS.ErrorCode =
                          CUCFCheckSET_OF(Coder, Type, vSetOf)) != ec_SUCCESS,
                          Coder,
                          return,
                          Coder->EMS.ErrorCode,
                          ERR_ARG("SET OF"));
}
#endif /* CODER_NOUSE_SET_OF */


#ifndef CODER_NOUSE_CHOICE
/*************************************************/
/******************* CHOICE **********************/
/*************************************************/

/* Extension marker */
#define PERChoiceExtMarker(iType) (((tASN1Choice*)iType)->ExtMarker)

/**************************************************
 * NAME: PEREncodeCHOICE
 *       
 *
 */

static void
PEREncodeCHOICE(tCoder* Coder, tASN1TypeInfo* Type, void* vChoice)
{
  tASN1Alternative* AltInfo = ((tASN1Choice*)Type)->Alternatives;
  CODER_NumOf_TYPE AltIndex;
  void* Alternative;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeCHOICE\n");
#endif

  VMSGetAlternativeCHOICE(Coder, vChoice, Type, AltInfo, Alternative);
  AltIndex = (CODER_NumOf_TYPE)(AltInfo - ((tASN1Choice*)Type)->Alternatives);
  
  if (PERChoiceExtMarker(Type) != -1)
    {
      if (AltIndex >= (CODER_NumOf_TYPE)PERChoiceExtMarker(Type))
        {
          /* Value from extension addition */
          PERPutBit(Coder, 1);

          if (((tASN1Choice*)Type)->NumOfAlts > 1)
            PEREncodeNormallySmallNonNegativeWholeNumber(Coder, AltIndex - PERChoiceExtMarker(Type));

          PEREncodeOPENTypeField(Coder, AltInfo->TypeInfo, Alternative);
          return;
        }
      else
        {
          /* Value from extension root */
          PERPutBit(Coder, 0);

          if (((tASN1Choice*)Type)->NumOfAlts > 1)
            PEREncodeConstrainedWholeNumber(Coder, 0, PERChoiceExtMarker(Type) - 1, AltIndex);
        }
    }
  else
    {
      if (((tASN1Choice*)Type)->NumOfAlts > 1)
        PEREncodeConstrainedWholeNumber(Coder, 0, ((tASN1Choice*)Type)->NumOfAlts - 1, AltIndex);
    }

  PEREncVal(Coder, AltInfo->TypeInfo, Alternative);
}

/**************************************************
 * NAME: PERDecodeCHOICE
 *       
 *
 */

static void
PERDecodeCHOICE(tCoder* Coder, tASN1TypeInfo* Type, void* vChoice, tVMSOpenTypeList* List)
{
  tASN1Alternative* AltInfo = ((tASN1Choice*)Type)->Alternatives;
  CODER_NumOf_TYPE AltIndex = 0;
  void* Alternative;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeCHOICE\n");
#endif

  VMSInitCHOICE(Coder, vChoice, Type);

  if (PERChoiceExtMarker(Type) != -1)
    {
      unsigned char Bit = PERGetBit(Coder);

      if (Bit == 1)
        {
          if (((tASN1Choice*)Type)->NumOfAlts > 1)
            PERDecodeNormallySmallNonNegativeWholeNumber(Coder, (tVMSULong*)&AltIndex);
          AltIndex = (CODER_NumOf_TYPE)(AltIndex + PERChoiceExtMarker(Type));

          DECODING_ERROR_HANDLER_EXP(AltIndex >= ((tASN1Choice*)Type)->NumOfAlts, Coder, return, ec_DEC_UnknownAlternative, NO_ARGS);

          AltInfo += AltIndex;
          if (AltInfo->Type != ct_Absent)
            {
              VMSSetAlternativeCHOICE(Coder, vChoice, Type, AltInfo, Alternative);

              PERDecodeOPENTypeField(Coder, AltInfo->TypeInfo, Alternative, List);
            }
          else
            DECODING_ERROR_HANDLER(Coder, return, ec_DEC_UnknownAlternative, NO_ARGS);

          return;
        }
      else
        {
          /* Value from extension root */

          if (((tASN1Choice*)Type)->NumOfAlts > 1)
            PERDecodeConstrainedWholeNumber(Coder, 0, PERChoiceExtMarker(Type) - 1, (tVMSInteger*)&AltIndex);
        }
    }
  else
    {
      if (((tASN1Choice*)Type)->NumOfAlts > 1)
        PERDecodeConstrainedWholeNumber(Coder, 0, ((tASN1Choice*)Type)->NumOfAlts - 1, (tVMSInteger*)&AltIndex);
    }

  if (AltIndex >= ((tASN1Choice*)Type)->NumOfAlts)
    DECODING_ERROR_HANDLER(Coder, return, ec_DEC_UnknownAlternative, NO_ARGS);

  AltInfo += AltIndex;
  if (AltInfo->Type != ct_Absent)
    {
      VMSSetAlternativeCHOICE(Coder, vChoice, Type, AltInfo, Alternative);

      PERDecVal(Coder, AltInfo->TypeInfo, Alternative, List);
    }
  else
    DECODING_ERROR_HANDLER(Coder, return, ec_DEC_UnknownAlternative, NO_ARGS);
}
#endif /* CODER_NOUSE_CHOICE */

#ifndef CODER_NOUSE_OPEN
/*************************************************/
/******************* OPEN ID *********************/
/*************************************************/

/**************************************************
 * NAME: PERDecodeOPEN_ID
 *       
 *
 */

static void
PERDecodeOPEN_ID(tCoder* Coder, tASN1TypeInfo* Type, void* vOpenId, tVMSOpenTypeList* List)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeOPEN_ID\n");
#endif
 
  PERDecVal(Coder, ((tASN1OpenId*)Type)->BaseType, vOpenId, NULL);
  PERPutOpenId(Coder, List, Type, vOpenId);
}

/*************************************************/
/********************* OPEN **********************/
/*************************************************/

/**************************************************
 * NAME: PEREncodeOPEN
 *       
 *
 */

static void
PEREncodeOPEN(tCoder* Coder, tASN1TypeInfo* Type, void* vOpen)
{
  void* Object;
  tASN1Object* ObjectInfo = NULL;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncodeOPEN\n");
#endif

  VMSGetObjectOPEN(Coder, vOpen, Type, ObjectInfo, Object);
  PEREncodeOPENTypeField(Coder, ObjectInfo->TypeInfo, Object);
}

/**************************************************
 * NAME: PERDecodeOPEN
 *       
 *
 */

static void
PERDecodeOPEN(tCoder* Coder, tASN1TypeInfo* Type, void* vOpen, tVMSOpenTypeList* List)
{
  tVMSOpenIdList* CurrId = List->Ids;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeOPEN\n");
#endif
  
  while (CurrId != NULL)
    {
      tASN1TypeInfo* CType = ((tASN1Open*)Type)->OpenIdType;

      while (CType->TypeClass == type_ASN1_DEFINED)
        CType = ((tASN1Defined*)CType)->BaseType;

      if ((void*)CType == CurrId->Type)
        {
          tASN1Object* Object;
          tVMSULong ObjIndex;
          
          Object = PERGetOpenTypeObject(Coder, Type, &ObjIndex, CurrId->Val);
          if (Object != NULL)
            {
              void* ObjectVal;
              
              VMSSetObjectOPEN(Coder, vOpen, Type, Object, ObjectVal);
              PERDecodeOPENTypeField(Coder, Object->TypeInfo, ObjectVal, /*List*/ NULL);
            }
          else
            DECODING_ERROR_HANDLER(Coder, return, ec_DEC_UnknownObject, NO_ARGS);
          break;
        }
      CurrId = CurrId->Next;
    }

  if (CurrId == NULL)
    {
      tVMSOpenTypeInfo Info;

      Info.DataPtr = Coder->ER.DataCurr;
      Info.AddInfo = Coder->ER.BitCurr;

      PERPutOpenBody(Coder, List, &Info, Type, vOpen);
      PERSkipOPENTypeField(Coder);
    }
}

/**************************************************
 * NAME: PERDecodeBodies
 *       
 *
 */

static void
PERDecodeBodies(tCoder* Coder, char* Changes, tVMSOpenTypeList* List)
{
  tVMSOpenBodyList *PrevBody, *CurrBody = List->Bodies;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeBodies\n");
#endif
  
  PrevBody = CurrBody;

  while (CurrBody != NULL)
    {
      tVMSOpenIdList* CurrId = List->Ids;
      tASN1TypeInfo* Type = ((tASN1Open*)(CurrBody->Type))->OpenIdType;

      while (Type->TypeClass == type_ASN1_DEFINED)
        Type = ((tASN1Defined*)Type)->BaseType;      

      while (CurrId != NULL)
        {
          if ((void*)Type == CurrId->Type)
            {
              /* Ok! We have decoded id! */
              tVMSULong ObjIndex = 0;

              tASN1Object* Object = PERGetOpenTypeObject(Coder, (tASN1TypeInfo*)(CurrBody->Type), &ObjIndex, CurrId->Val);

              if (Object != NULL)
                {
                  void* ObjectVal;
                  tVMSOpenTypeInfo SInfo;

                  SInfo.DataPtr = Coder->ER.DataCurr;
                  SInfo.AddInfo = Coder->ER.BitCurr;

                  Coder->ER.DataCurr = CurrBody->DataPtr;
                  Coder->ER.BitCurr = CurrBody->AddInfo;
                  
                  VMSSetObjectOPEN(Coder, CurrBody->Val, CurrBody->Type, Object, ObjectVal);
                  PERDecodeOPENTypeField(Coder, Object->TypeInfo, ObjectVal, NULL);
                  
                  
                  Coder->ER.DataCurr = SInfo.DataPtr;
                  Coder->ER.BitCurr = SInfo.AddInfo;

                  CurrBody->DataPtr = NULL;
                  break;
                }
              else
                DECODING_ERROR_HANDLER(Coder, return, ec_DEC_UnknownObject, NO_ARGS);      
            }
          CurrId = CurrId->Next;
        }

      if (CurrBody->DataPtr == NULL)
        {
          /* We have decoded body. Lets free unused memory */
          (*Changes) |= 1; /* Changes in List */

          if (CurrBody == List->Bodies)
            {
              /* First element */
              List->Bodies = CurrBody->Next;

              CUCFFree(Coder, CurrBody, sizeof(tVMSOpenBody), 0);
              CurrBody = PrevBody = List->Bodies;
            }
          else
            {
              PrevBody->Next = CurrBody->Next;
              CUCFFree(Coder, CurrBody, sizeof(tVMSOpenBody), 0);
              CurrBody = PrevBody->Next;
            }
        }
      else
        {
          PrevBody = CurrBody;
          CurrBody = CurrBody->Next;
        }
    }
}

/**************************************************
 * NAME: PERDecodeSkipedValues
 *       
 *
 */

static void
PERDecodeSkipedValues(tCoder* Coder, tVMSOpenTypeList* List)
{
  char Changes = 0;  /* 1 - Changes are presents, 0 - no any changes */
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecodeSkipedValues\n");
#endif

  for (;;)
    {
      if (List->Bodies != NULL)
        PERDecodeBodies(Coder, &Changes, List);

      if (Changes == 0)
        break;
      
      Changes = 0;
    }
}
#endif /* CODER_NOUSE_OPEN */

#endif /* !CODER_REMOVE_PER */
