/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifdef DEBUG_INSTRUMENT_SIDE
#ifdef __cplusplus
extern "C" {
#endif
#endif

#define ENV_TTD_DEBUGGER_PORT "TTD_DEBUGGER_PORT"
#define ENV_TTD_DEBUGGER_PORT_FILE "TTD_DEBUGGER_PORT_FILE"
#define XDEFAULTSERVPORT 4000

#ifndef DEBUG_INSTRUMENT_SIDE
/******************************************************************************/
/* Debugger Agent side */

extern struct ComCtx_struct * xDAComInit(void);

extern int/*xbool*/ xDAComUp(struct ComCtx_struct *ctx);

extern void xDAComPoll(struct ComCtx_struct *ctx,void (*cb)(/*nodelete*/ char *cmd,/*nodelete*/ char *reqid),long timeout);
extern int/*xbool*/ xDAComSend(struct ComCtx_struct *ctx,const char *msg);

/* function of sctdamsg declared here to avoid nasty includes */
extern void xDAMsgHandleData(const char *data,int length,void (*cb)(/*nodelete*/ char *cmd,/*nodelete*/ char *reqid));

#else
/******************************************************************************/
/* Debug Instrument side */

extern struct DbgComCtx *DbgInitComm(const char *xHostName, int xPortNbr);
extern int DbgComPort(struct DbgComCtx *);
extern int DbgBreakComm(struct DbgComCtx *ctx);
extern int DbgSendReq(struct DbgComCtx *ctx,const char *cmd);
extern int DbgGetString(struct DbgComCtx *ctx,char **buf);
extern void DbgComIgnoreErrors(struct DbgComCtx *ctx);

/******************************************************************************/
#endif

/* utility buffer (exported because it is used by sctdamsg.c) */
typedef struct {
	int size; /* ending zero included when reading (zero need not be written) */
	char *buf;
	int reading;
	/*boolean*/ int eof; /* TRUE if a zero was read */
	int writing; /* index of the char to be written */
} Charbuf;

extern void CB_clear(Charbuf *cb);
extern void CB_init(Charbuf *cb);
extern void CB_reset(Charbuf *cb);
/* writing functions */
extern void CB_putc(Charbuf *cb,char c);
extern void CB_unputc(Charbuf *cb,char c);
extern void CB_puts(Charbuf *cb,const char *s);
extern void CB_nputc(Charbuf *cb,const char *s,int l);
#define CB_eof(cb) ((cb)->eof)
extern int CB_getc(Charbuf *cb);

/******************************************************************************/

#ifdef DEBUG_INSTRUMENT_SIDE
#ifdef __cplusplus
}
#endif
#endif


