# Project TCL library file

proc IsAFolder {identObj} {
  expr ![string compare [Class $identObj] Folder]
}

proc IsAProject {identObj} {
  expr ![string compare [Class $identObj] Project]
}

proc IsEmpty {identObj} {
  expr ![string compare $identObj ""]
}

proc AddFolder {FolderName FileExtension ObjDest} { 
global project	
	set FolderId [Create $project Folder]
	if {[IsAFolder $ObjDest]} {
		AddRole $FolderId folder $ObjDest
	}

	if {[IsAProject $ObjDest]} {
		AddRole $ObjDest root $FolderId
	}
	SetAtt $FolderId name "$FolderName"
	SetAtt $FolderId extensions "$FileExtension"
return $FolderId
}


