# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

proc ReportConstraints { elmt } {

  if { [catch { set constraints [u2::GetEntities $elmt InformalConstraint] } ] } { return };

  if { [llength $constraints] == 0 } { return };#end_if there are no comments to report

  html_paragraph ""
  html_table_start

  html_table_row_start
  html_table_heading "Constraints"
  html_table_row_end

  foreach c $constraints {

    set txt [u2::GetValue $c "InformalText"]
    set txt [CorrectForHTML $txt]

    html_table_row_start
    html_table_cell_start

    foreach cl [split $txt "\n"] {
      html_print $cl
      html_br
    };#end_foreach constraint line

    html_table_cell_end
    html_table_row_end

  };#end_foreach constraint

  html_table_end

};#end_proc ReportConstraints
