# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

proc ReportPortInterfaces { elmt headingLevel } {

  if { [catch { set requiredI [u2::GetEntities $elmt Required] } ] } { return };
  if { [catch { set realizedI [u2::GetEntities $elmt Realized] } ] } { return };

  if { [llength $requiredI] == 0 && [llength $realizedI] == 0 } {
    return
  } ;# end_if no interfaces to report

  if { $headingLevel != 0 } {
    html_paragraph ""
    html_heading $headingLevel "" "Interfaces"
  }

  # Report Port-specific attributes
  if { [llength $requiredI] != 0 } { html_bullet "Required: [BuildNameListString $requiredI]" }
  if { [llength $realizedI] != 0 } { html_bullet "Realized: [BuildNameListString $realizedI]" }

};#end_proc ReportPortInterfaces
