# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# ========= HTML Report Generator Addin for Tau G2 v2.4.0 =========

proc ReportUseCase { p } {

  global gUseCases
  global gActors

  global gUseCaseDescriptiveDiagrams

  global flag_UseCaseReports
  global cbxTrue cbxFalse

  global flag_Debug
  if { $flag_Debug == 1 } { output "(Debug)\tReportUseCase!\n" }

  set flag_UseCaseStereotypes $cbxTrue
  set flag_UseCaseComments $cbxTrue
  set flag_UseCaseConstraints $cbxTrue

  if { $flag_UseCaseReports != $cbxTrue } { return; };#end_if Use case reports don't have to be generated

  set pname [GetElementName $p]  ;# Get passed element name


  html_start_name "usecasereport"
  html_heading 1 "" "Use Case Reports for Package $pname"
  html_end_name


  # Generate reference list of Actors

  html_heading 2 "" "Actors"
  GenerateReferenceList $gActors

  # Generate Actor reports

  set flag_ActorAbstract $cbxFalse
  set flag_ActorExternal $cbxTrue
  set flag_ActorVisibility $cbxTrue
  set flag_ActorParents $cbxFalse
  set flag_ActorStereotypes $flag_UseCaseStereotypes
  set flag_ActorComments $flag_UseCaseComments
  set flag_ActorConstraints $flag_UseCaseConstraints

  foreach actor $gActors {
    ReportStdElement $actor 3 $flag_ActorAbstract $flag_ActorExternal $flag_ActorVisibility $flag_ActorParents $flag_ActorStereotypes $flag_ActorComments $flag_ActorConstraints
  };#end_foreach actor to report


  html_hr


  # Generate reference list of Use Cases

  html_heading 2 "" "Use Cases"
  GenerateReferenceList $gUseCases


  # Generate Use Case reports

  set flag_UseCaseAbstract $cbxTrue
  set flag_UseCaseExternal $cbxTrue
  set flag_UseCaseVisibility $cbxTrue
  set flag_UseCaseParents $cbxTrue

  set flag_InteractionOperations $cbxTrue

  foreach uc $gUseCases {

    ReportStdElement $uc 3 $flag_UseCaseAbstract $flag_UseCaseExternal $flag_UseCaseVisibility $flag_UseCaseParents $flag_UseCaseStereotypes $flag_UseCaseComments $flag_UseCaseConstraints

    ReportInteraction $uc 4

  };#end_foreach use case to report

  html_hr

};#end_proc ReportUseCase
