# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
namespace eval requirements {

source [file join $addin::scriptDir RequirementsUtils.tcl]
source [file join $addin::scriptDir ExternalReferences.tcl]

proc RequirementsReport { context {type basic} } { 
	ReportRequirements [ExecuteQueryExpression "GetAllEntities().select(IsKindOf(\"Class\") and HasAppliedStereotype(\"requirement\"))" $context] $type
}

proc DependencyReport { context } {
	ReportDependencies [ExecuteQueryExpression "GetAllEntities().select(IsKindOf(\"Dependency\") and (HasAppliedStereotype(\"trace\") or HasAppliedStereotype(\"refine\") or HasAppliedStereotype(\"satisfy\")))" $context]
}

proc NonSatisfiedReport { context {type basic} } {
	ReportRequirements [ExecuteQueryExpression "GetAllEntities().select(IsKindOf(\"Class\") and HasAppliedStereotype(\"requirement\") and not GetReferingEntities(\"Supplier\").exists(HasAppliedStereotype(\"satisfy\")))" $context] $type
}

proc NonVerifiedReport { context {type basic} } {
	ReportRequirements [ExecuteQueryExpression "GetAllEntities().select(IsKindOf(\"Class\") and HasAppliedStereotype(\"requirement\") and not GetReferingEntities(\"Supplier\").exists(HasAppliedStereotype(\"verify\")))" $context]  $type
}

proc SatisfiedReport { context {type basic} } {
	ReportRequirements [ExecuteQueryExpression "GetAllEntities().select(IsKindOf(\"Class\") and HasAppliedStereotype(\"requirement\") and GetReferingEntities(\"Supplier\").exists(HasAppliedStereotype(\"satisfy\")))" $context] $type
}

proc VerifiedReport { context {type basic} } {
	ReportRequirements [ExecuteQueryExpression "GetAllEntities().select(IsKindOf(\"Class\") and HasAppliedStereotype(\"requirement\") and GetReferingEntities(\"Supplier\").exists(HasAppliedStereotype(\"verify\")))" $context]  $type
}

}
