// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:20 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:17 MEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// prevent dxl timeout dialog
pragma runLim, 0

Skip openedModules = null

//
// Write 'extensionPresentation' like this:
// <<extensionPresentation(.control = EditControl (.autoLayout = GrowRight, isMultiLine = true, height = 100.).)>> 
//
void writeMultilineExtensionPresentation(Stream s)
{
    writeToStream(s, "<cStereotypeInstance>\n<InstanceExpr>\n<rInstanceOf R=\"uid:@TTDExtensionManagement@extensionPresentation\"/>\n<cExpression>\n<BinaryExpr>\n")
    writeToStream(s, "<rOperation>\n<Ident Name=\"=\">\n<rDefinition R=\"uid:@Predefined@Any@=@Any@Any@Any\"/>\n</Ident>\n</rOperation>\n<cRightOperand>\n")
    writeToStream(s, "<InstanceExpr>\n<rInstanceOf>\n<Ident Name=\"EditControl\">\n")
    writeToStream(s, "</Ident>\n</rInstanceOf>\n<cExpression>\n<BinaryExpr>\n<rOperation>\n<Ident Name=\"=\">\n<rDefinition R=\"uid:@Predefined@Integer@=@Integer@Integer@Integer\"/>\n")
    writeToStream(s, "</Ident>\n</rOperation>\n<cRightOperand>\n<Ident Name=\"GrowRight\">\n</Ident>\n</cRightOperand>\n")
    writeToStream(s, "<cLeftOperand>\n<Ident Name=\"autoLayout\">\n</Ident>\n</cLeftOperand>\n</BinaryExpr>\n")
    writeToStream(s, "<BinaryExpr>\n<rOperation>\n<Ident Name=\"=\">\n<rDefinition R=\"uid:@Predefined@Boolean@=@Boolean@Boolean@Boolean\"/>\n</Ident>\n")
    writeToStream(s, "</rOperation>\n<cRightOperand>\n<Ident Name=\"true\">\n<rDefinition R=\"uid:@Predefined@Boolean@true\"/>\n</Ident>\n</cRightOperand>\n")
    writeToStream(s, "<cLeftOperand>\n<Ident Name=\"isMultiLine\">\n</Ident>\n</cLeftOperand>\n</BinaryExpr>\n")
    writeToStream(s, "<BinaryExpr>\n<rOperation>\n<Ident Name=\"=\">\n<rDefinition R=\"uid:@Predefined@Integer@=@Integer@Integer@Integer\"/>\n</Ident>\n")
    writeToStream(s, "</rOperation>\n<cRightOperand>\n<IntegerValue ValueString=\"100\">\n</IntegerValue>\n</cRightOperand>\n<cLeftOperand>\n<Ident Name=\"height\">\n")
    writeToStream(s, "</Ident>\n</cLeftOperand>\n</BinaryExpr>\n</cExpression>\n</InstanceExpr>\n</cRightOperand>\n")
    writeToStream(s, "<cLeftOperand>\n<Ident Name=\"control\">\n<rDefinition R=\"uid:@TTDExtensionManagement@control\"/>\n</Ident>\n</cLeftOperand>\n")
    writeToStream(s, "</BinaryExpr>\n</cExpression>\n</InstanceExpr>\n</cStereotypeInstance>\n")
}

void writeSimpleExtensionPresentation(Stream s)
{
    writeToStream(s, "<cStereotypeInstance>\n<InstanceExpr>\n<rInstanceOf R=\"uid:@TTDExtensionManagement@extensionPresentation\"/>\n<cExpression>\n<BinaryExpr>\n")
    writeToStream(s, "<rOperation>\n<Ident Name=\"=\">\n<rDefinition R=\"uid:@Predefined@Any@=@Any@Any@Any\"/>\n</Ident>\n</rOperation>\n<cRightOperand>\n")
    writeToStream(s, "<InstanceExpr>\n<rInstanceOf>\n<Ident Name=\"EditControl\">\n")
    writeToStream(s, "</Ident>\n</rInstanceOf>\n<cExpression>\n")
    writeToStream(s, "<BinaryExpr>\n<rOperation>\n<Ident Name=\"=\">\n<rDefinition R=\"uid:@Predefined@Integer@=@Integer@Integer@Integer\"/>\n")
    writeToStream(s, "</Ident>\n</rOperation>\n<cRightOperand>\n<Ident Name=\"GrowRight\">\n</Ident>\n</cRightOperand>\n")
    writeToStream(s, "<cLeftOperand>\n<Ident Name=\"autoLayout\">\n</Ident>\n</cLeftOperand>\n</BinaryExpr>\n")
    writeToStream(s, "</cExpression>\n</InstanceExpr>\n</cRightOperand>\n")
    writeToStream(s, "<cLeftOperand>\n<Ident Name=\"control\">\n<rDefinition R=\"uid:@TTDExtensionManagement@control\"/>\n</Ident>\n</cLeftOperand>\n")
    writeToStream(s, "</BinaryExpr>\n</cExpression>\n</InstanceExpr>\n</cStereotypeInstance>\n")
}

// Creates stereotype definition matching all attributes displayed in columns in 
// the current view and appends it onto the buffer.
//
void writeAttributeStereotype(Stream s, Module m)
{
    writeToStream(s, "<Stereotype Name=\"requirementAttributes\">\n<cOwnedMember>\n")

    // Hard import of "Object Number"
    string tmps_taunumber_name = u2String(TAU_ATTR_NUMBER_NAME)
    writeToStream(s, "<Attribute Name=\"" tmps_taunumber_name "\">\n")
    writeSimpleExtensionPresentation(s)
    writeToStream(s, "<rType>\n<Ident Name=\"Charstring\">\n<rDefinition R=\"uid:@Predefined@Charstring\"/>\n</Ident>\n</rType>\n</Attribute>\n")
    
    // to save from duplicate attributes
    Skip writenAttrList=create
    
    Column c 
    for c in m do 
    {
        string attributeName = ""
        if (!IsValidColumn(c, attributeName))
            continue
            
        bool wasMultiWriten = false
        string u2attributeName = u2String(attributeName)
        if(writenAttrList!=null)
        {
            if(find(writenAttrList, u2attributeName))
            {
                continue
            }
            put(writenAttrList, u2attributeName, false)
        }
        writeToStream(s, "<Attribute Name=\"" u2attributeName "\">\n")
        AttrDef ad = find(m, attributeName) 
        if(ad!=null && ad.multi)
        {
            AttrType at = ad.type
            if(at!=null && at.type==attrEnumeration)
            {
                writeMultilineExtensionPresentation(s)
                wasMultiWriten = true
            }
        }
        if(!wasMultiWriten)
        {
            writeSimpleExtensionPresentation(s)
        }
        writeToStream(s, "<rType>\n<Ident Name=\"Charstring\">\n<rDefinition R=\"uid:@Predefined@Charstring\"/>\n</Ident>\n</rType>\n</Attribute>\n")
    }
    
    if(writenAttrList!=null)
    {
        delete writenAttrList
        writenAttrList=null
    }

    writeToStream(s, "</cOwnedMember>\n<cExtension>\n<Extension>\n<cRange>\n<ClosedRange>\n<cLowerBound>\n<IntegerValue ValueString=\"0\">\n</IntegerValue>\n</cLowerBound>\n<cUpperBound>\n<IntegerValue ValueString=\"1\">\n</IntegerValue>\n</cUpperBound>\n</ClosedRange>\n</cRange>\n<rExtended>\n<Ident Name=\"Requirement\">\n<cScopeQualifier>\n<Ident Name=\"TTDRequirementView\">\n<rDefinition R=\"uid:@RequirementView\"/>\n</Ident>\n</cScopeQualifier>\n</Ident>\n</rExtended>\n</Extension>\n</cExtension>\n</Stereotype>\n")
}


// Helper to print a binary expression. Given an operand name and a value,
// writes a full binary expression
void writeBinaryExpr(Buffer b, string name, string value)
{
    b += "<BinaryExpr>\n<rOperation>\n<Ident Name=\"=\">\n<rDefinition R=\"uid:@Predefined@Collection@=@Collection@Collection@Collection\"/>\n</Ident>\n</rOperation>\n<cRightOperand>\n"

    b += "<CharstringValue ValueString=\"" value "\">\n"

    b += "</CharstringValue>\n</cRightOperand>\n<cLeftOperand>\n"

    b += "<Ident Name=\"" name "\">\n"

    b += "</Ident>\n</cLeftOperand>\n</BinaryExpr>\n"
}

// Helper to print a binary expression. Given an operand name and a value,
// writes a full binary expression
void writeBinaryExpr(Stream s, string name, string value)
{
    writeToStream(s, "<BinaryExpr>\n<rOperation>\n<Ident Name=\"=\">\n<rDefinition R=\"uid:@Predefined@Collection@=@Collection@Collection@Collection\"/>\n</Ident>\n</rOperation>\n<cRightOperand>\n")

    writeToStream(s, "<CharstringValue ValueString=\"" value "\">\n")

    writeToStream(s, "</CharstringValue>\n</cRightOperand>\n<cLeftOperand>\n")

    writeToStream(s, "<Ident Name=\"" name "\">\n")

    writeToStream(s, "</Ident>\n</cLeftOperand>\n</BinaryExpr>\n")
}

void writeAttributes(Stream s, Module m, Object o)
{
    Buffer tmpBuf = create
    tmpBuf += "<InstanceExpr>\n<rInstanceOf>\n<Ident Name=\"requirementAttributes\">\n</Ident>\n</rInstanceOf>\n<cExpression>\n"

    // Hard import of "Object Number"
    string tmps_taunumber_name=u2String(TAU_ATTR_NUMBER_NAME)
    string tmps_taunumber=u2String(getTAUNumber(o))
    writeBinaryExpr(tmpBuf, tmps_taunumber_name, tmps_taunumber)
    
    Skip writenAttrList=create
    
    int columnCount = 0
    Column c 
    for c in m do 
    {
        string attributeName = ""
        if (!IsValidColumn(c, attributeName))
            continue

        string tmps_attrname=u2String(attributeName)
        
        if(writenAttrList!=null)
        {
            if(find(writenAttrList, tmps_attrname))
            {
                continue
            }
            put(writenAttrList, tmps_attrname, false)
        }
        
        string tmps_attrvalue=u2String(probeAttr_(o,attributeName))

        columnCount++;
        
        writeBinaryExpr(tmpBuf, tmps_attrname, tmps_attrvalue)
    }
    
    if(writenAttrList!=null)
    {
        delete writenAttrList
        writenAttrList=null
    }

    tmpBuf += "</cExpression>\n</InstanceExpr>\n"

    writeToStream(s, stringOf(tmpBuf))
        
    delete tmpBuf
}

// Writes a link as a <<trace>> dependency. Qualifies the name of the supplier if needed.
//note: this function is unused, try to remove at next review
void writeReferenceLink(Stream s, Link l)
{
    Object sourceObject = source(l)
    if (null sourceObject)
        return

    ModName_ targetModuleModName = target(l)
	
    bool bWasOpened = false
    string errMsg = null
	
    // the 'targetModule' is needed also to check module attribute 'TLOG Module Guid'
    string targetModuleID=uniqueID (targetModuleModName)
    Item iitem = item(fullName targetModuleModName)
    Module targetModule = openModule(iitem, READ_MODE, null, null, bWasOpened, false, errMsg)
    if (!null targetModule && bWasOpened && !null openedModules)
        put(openedModules, targetModule,targetModule)

    Object targetObject = target(l)
    if (null targetObject)    
        return
	    
    // link to surogate object from old OLD integration
    // link on formal module imported by old integration 
    // we send as new dependency link on proxy object "Doors:moduleID.objectID"
    string tau_formal_guid=probeAttr_(targetModule,"TLOG Module Guid")
    string tau_surogate_guid=probeAttr_(targetObject,"UML Guid")
    if(targetModuleID!="" && (tau_surogate_guid!="" || tau_formal_guid!=""))
    {
        writeToStream(s, "<Dependency>\n<cStereotypeInstance>\n")
        writeToStream(s, "<InstanceExpr>\n<rInstanceOf R=\"uid:@Predefined@externalObjectReference\"/>\n<cExpression>\n")
        //writeBinaryExpr(s, "target", "uid:" tau_surogate_guid "" )
        //writeBinaryExpr(s, "target", "Doors:" targetModuleID "." getTAUID(targetObject) "")
        writeBinaryExpr(s, "target", "tlog:Doors:" targetModuleID "." getTAUID(targetObject) "")
        writeToStream(s, "</cExpression>\n</InstanceExpr>\n")
        writeToStream(s, "<InstanceExpr>\n<rInstanceOf R=\"uid:@Predefined@trace\"/>\n</InstanceExpr>\n</cStereotypeInstance>\n")
        writeToStream(s, "<rSupplier R=\"uid:@Predefined@ExternalObject\"/>\n</Dependency>\n")
        return
    }
    
    // all other links commited as full PATH to resolve by name
    
    writeToStream(s, "<Dependency>\n<cStereotypeInstance>\n<InstanceExpr>\n<rInstanceOf R=\"uid:@Predefined@trace\"/>\n</InstanceExpr>\n</cStereotypeInstance>\n<rSupplier>\n")

    string tmps_name = u2String(getTAUName(targetObject))
    writeToStream(s, "<Ident Name=\"" tmps_name "\">\n")
        
    int levels = 0
    
    Object targetParent = parent(targetObject)
    Object sourceParent = parent(sourceObject)

    if (targetParent != sourceParent)
    {        
        while (null != targetParent)
        {
            if (isProcessedObject(targetParent))
            {
                writeToStream(s, "<cScopeQualifier>\n")
                string tmps_name = u2String(getTAUName(targetParent))
                writeToStream(s, "<Ident Name=\"" tmps_name "\">\n")
                levels += 1
            }
            targetParent = parent(targetParent)
        }                
    }

    string targetModuleName = target(l)
    string sourceModuleName = source(l)

    if (targetModuleName != sourceModuleName)
    {
        writeToStream(s, "<cScopeQualifier>\n")
        writeToStream(s, "<Ident Name=\"" targetModuleName "\">\n")
        levels += 1
    }

    int i    
    for (i = 0; i < levels; i++)
    {
        writeToStream(s, "</Ident>\n</cScopeQualifier>\n")
    }

    writeToStream(s, "</Ident>\n")

    writeToStream(s, "</rSupplier>\n")
    writeToStream(s, "</Dependency>\n")
}

// Writes a link as a <<trace>> dependency with supplier on 'externalObject' for all links
void writeLink(Stream s, Link l, string strDependencyStereotype)
{
    Object sourceObject = source(l)
    if (null sourceObject)
        return
    ModName_ targetModuleName = target(l)
    string targetModuleID=uniqueID (targetModuleName)
    int targetObjectID=targetAbsNo(l)
    if(targetModuleID!="" && targetObjectID>0)
    {
        writeToStream(s, "<Dependency>\n<cStereotypeInstance>\n")
        writeToStream(s, "<InstanceExpr>\n<rInstanceOf R=\"uid:@Predefined@externalObjectReference\"/>\n<cExpression>\n")
        writeBinaryExpr(s, "target", "tlog:Doors:" targetModuleID "." targetObjectID "")
        writeToStream(s, "</cExpression>\n</InstanceExpr>\n")
        writeToStream(s, "<InstanceExpr>\n<rInstanceOf R=\"uid:" strDependencyStereotype "\"/>\n</InstanceExpr>\n</cStereotypeInstance>\n")
        writeToStream(s, "<rSupplier R=\"uid:@Predefined@ExternalObject\"/>\n</Dependency>\n")
    }
}

void writeObject(Stream s, Module m, Object o, string strDependencyStereotype)
{
    if (null o || isDeleted(o) || !canRead(o))
        return
    
    bool isOut = false
    bool isOutAttributes = false
    string stereotypeName=""
    string stereotypeIdAttribute=""
    if(table(o))
    {
        isOut = true
        stereotypeName = "@Doors@table"
        stereotypeIdAttribute = "id"
    }
    else if(row(o))
    {
        isOut = true
        stereotypeName = "@Doors@row"
        stereotypeIdAttribute = "id"
    }
    else if (isVisible(o))
    {
        isOut = true
        isOutAttributes=true
        stereotypeName = "@Requirements@requirement"
        stereotypeIdAttribute = "Id"
    }
    
    if (isOut)
    {
        string objName=u2String(getTAUName(o))
        writeToStream(s, "<Class Name=\"" objName "\" Visibility=\"VkPublic\">\n")
        writeToStream(s, "<cStereotypeInstance>\n")
        writeToStream(s, "<InstanceExpr>\n")
        writeToStream(s, "<rInstanceOf R=\"uid:" stereotypeName "\"/>\n")
        writeToStream(s, "<cExpression>\n")
        if(isOutAttributes)
        {
            string tmps_heading=u2String(getTAUHeading(o))
            string tmps_text=u2String(getTAUText(o))
            string tmps_short_text=u2String(getShortText(o))
            writeBinaryExpr(s, "Heading", tmps_heading)
            writeBinaryExpr(s, "Text", tmps_text)
            writeBinaryExpr(s, "ShortText", tmps_short_text)
        }
        writeBinaryExpr(s, stereotypeIdAttribute, getTAUID(o))
        writeToStream(s, "</cExpression>\n")
        writeToStream(s, "</InstanceExpr>\n")
        if(isOutAttributes)
        {
            writeAttributes(s, m, o)
        }
        writeToStream(s, "</cStereotypeInstance>\n")
    }

    // Visible subtree
    if (!leaf(o)) 
    {
        if(isOut)
            writeToStream(s, "<cOwnedMember>\n")
        Object child        
        for child in o do 
        {
            writeObject(s, m, child, strDependencyStereotype)
        }
        if(isOut)
            writeToStream(s, "</cOwnedMember>\n")
    }

    if (isProcessedObject(o))
    {
        Link l
        bool hasLinks = false
        for l in o->"*" do
        {
            if (!hasLinks)
            {
                writeToStream(s, "<cClientDependency>\n")
                hasLinks = true
            }
            writeLink(s, l, strDependencyStereotype)
        } 
        if (hasLinks)
            writeToStream(s, "</cClientDependency>\n")
    }
    
    if(isOut)
        writeToStream(s, "</Class>\n")
}

// Writes a formal module in .u2 format to the buffer
void writeU2File(Stream s, Module m, string strDependencyStereotype)
{
	writeToStream(s, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<u2 OMVersion=\"3.7\" StorageVersion=\"4\">\n<Resource>\n<cHiddenStereotypeInstance>\n<InstanceExpr>\n<rInstanceOf R=\"uid:@Predefined@modelDependency\"/>\n<cExpression>\n<BinaryExpr>\n<rOperation R=\"uid:@Predefined@Collection@=@Collection@Collection@Collection\"/>\n<cRightOperand>\n<CharstringValue ValueString=\"urn:u2:etc/Requirements.u2\">\n</CharstringValue>\n</cRightOperand>\n<cLeftOperand>\n<Ident Name=\"strUri\">\n</Ident>\n</cLeftOperand>\n</BinaryExpr>\n</cExpression>\n</InstanceExpr>\n</cHiddenStereotypeInstance>\n")

    Item i = item fullName m
    string moduleId = uniqueID(i)
	string id = moduleId "@" (intOf today) ""

	writeToStream(s, "<rRoot R=\"uid:" id "\"/>\n</Resource>\n<Package Guid=\"" id "\" Name=\"" name(m) "\">\n<cOwnedMember>\n")
        
	Object o	
	for o in top(m) do 
	{
            writeObject(s, m, o, strDependencyStereotype)
	}

        string viewName = currentView(m)
        
        //if (viewName != "Standard view")
        //{
        writeAttributeStereotype(s, m)
        //}
        
        writeToStream(s, "</cOwnedMember>\n")    
        

        // Apply formal module stereotype
        writeToStream(s, "<cStereotypeInstance>\n<InstanceExpr>\n<rInstanceOf>\n<Ident Name=\"formalModule\">\n<cScopeQualifier>\n<Ident Name=\"TTDDoors\">\n</Ident>\n</cScopeQualifier>\n</Ident>\n</rInstanceOf>\n<cExpression>\n")
        writeBinaryExpr(s, "id", moduleId)

        string strBaseline = baselineString(moduleVersion(m))
        if ("" != strBaseline && "Current" != strBaseline)
            writeBinaryExpr(s, "baseline", strBaseline)

        writeBinaryExpr(s, "view", viewName)
        writeBinaryExpr(s, "lastSynchronized", getDateAndTime())

        writeToStream(s, "</cExpression>\n</InstanceExpr>\n</cStereotypeInstance>\n")

        writeToStream(s, "</Package>\n</u2>\n")
}

void importModule(string moduleID, string strView, string strBaseline, string strDependencyStereotype, string strU2File)
{
    if (!canOpenFile(strU2File, true))
    {
        returnResult("IDS_CANNOT_OPEN_FILE: " lastError())
        return
    }

    if (strView == TAU_STANDARD_VIEW)
    {
        strView = null
    }
   
    bool bWasOpened = false
    string errMsg = null
   
    Item i = itemFromID(moduleID)
    Module m = openModule(i, READ_MODE, strView, strBaseline, bWasOpened, (!null strView), errMsg)
    if (!null errMsg)
    {
        returnResult(errMsg)
        return
    }

    if (!null m)
    {
        openedModules = create

        if (bWasOpened)
	    put(openedModules, m, m)
	    
        Stream out = getStream(strU2File)
        if (null out)
        {
            delete openedModules
            returnResult("IDS_CANNOT_OPEN_FILE: " lastError())
            return            
        }
		
		if(strDependencyStereotype=="")
			strDependencyStereotype = "@Predefined@trace" //default value
			
        writeU2File(out, m, strDependencyStereotype)

	Module tmpModule
	for tmpModule in openedModules do
	{
	    if (!null tmpModule)
		close(tmpModule)
	}

	delete openedModules
	
        close out
    }

    returnResult("true")
}
