/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:23 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "cucf.h"

void MMSRelease(tCoder* Coder)
{
  if (Coder->MMS.MMSFirst != NULL)
    {
      tMMSItem* CurrItem = Coder->MMS.MMSFirst;
      tMMSItem* PrevItem;
      while (CurrItem->Next != NULL)
        {
          PrevItem = CurrItem;
          CurrItem = CurrItem->Next;
          CUCF_FREE(PrevItem->MemPtr, 0, 0);
          CUCF_FREE(PrevItem, sizeof(tMMSItem), 0);
        }
      CUCF_FREE(CurrItem->MemPtr, 0, 0);
      CUCF_FREE(CurrItem, sizeof(tMMSItem), 0);
      Coder->MMS.MMSFirst = NULL;
    }
  Coder->MMS.MMSFirst = NULL;
}

void*
MMSAlloc(tCoder* Coder, size_t Size)
{
  tMMSItem* CurrItem = (tMMSItem*)CUCF_ALLOC(sizeof(tMMSItem), 0);

  MEMORY_ERROR_HANDLER_EXP(CurrItem == NULL, Coder, return NULL, ec_MEM_NotEnoughMemory, NO_ARGS)
  CurrItem->Next = Coder->MMS.MMSFirst;
  CurrItem->MemPtr = CUCF_ALLOC(Size, 0);
  if (CurrItem->MemPtr == NULL)
    {
      CUCF_FREE(CurrItem, sizeof(tMMSItem), 0);
      MEMORY_ERROR_HANDLER(Coder, return NULL, ec_MEM_NotEnoughMemory, NO_ARGS)
    }
  Coder->MMS.MMSFirst = CurrItem;
  return CurrItem->MemPtr;
}

void
MMSFree(tCoder* Coder, void* Ptr)
{
  tMMSItem* CurrItem = Coder->MMS.MMSFirst;

  if (CurrItem != NULL)
    {
      if (CurrItem->MemPtr == Ptr)
        {
          Coder->MMS.MMSFirst = CurrItem->Next;
          CUCF_FREE(Ptr, 0, 0);
          CUCF_FREE(CurrItem, sizeof(tMMSItem), 0);
        }
      else
        {
          tMMSItem* NextItem = CurrItem->Next;

          while (NextItem != NULL)
            {
              if (NextItem->MemPtr == Ptr)
                {
                  CurrItem->Next = NextItem->Next;
                  CUCF_FREE(Ptr, 0, 0);
                  CUCF_FREE(NextItem, sizeof(tMMSItem), 0);
                  return;
                }
              CurrItem = NextItem;
              NextItem = NextItem->Next;
            }
          INTERNAL_ERROR_HANDLER(Coder, return, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
        }
    }
  else
    {
      INTERNAL_ERROR_HANDLER(Coder, return, ec_INT_InternalError, ERR_ARG(__FILE__) ERR_ARG(__LINE__));
    }
}
