# Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:28 MEST 2009
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# Generate HTML report from the command line

set bOk "false"
set projFile ""
set argc [llength $argv]

if { [expr $argc == 1] } {  
  set bOk "true"
  set projFile [lindex $argv 0]
} else {
  output "usage: [info nameofexecutable] -script [info script] project.ttp\n"
}

if {$bOk == "true"} {

  std::OpenDocument "$projFile"
  set curProject [std::GetActiveProject]

  variable name ModelBrowser
  set installDir [std::GetInstallationDirectory]
  set scriptDir [file join $installDir addins $name Script]
  foreach inc [list GetElementName.tcl CorrectMetaClassName.tcl htmllib.tcl writeln.tcl ReportStdElement.tcl GetElementType.tcl ReportComments.tcl ReportProperties.tcl ReportType.tcl ReportOwner.tcl ReportAbstract.tcl ReportActive.tcl ReportExternal.tcl ReportVisibility.tcl ReportParents.tcl ReportConstraints.tcl ReportDefaultValue.tcl ReportExtensions.tcl ReportDependencies.tcl ReportStereotypes.tcl ReportParameters.tcl ReportPortInterfaces.tcl ReportAttributes.tcl ReportPorts.tcl ReportConnectors.tcl ReportSignals.tcl GetDirection.tcl FilterList.tcl ReportStates.tcl ReportInlineStates.tcl ReportActionNodes.tcl ReportOwnedMembers.tcl ReportSignalListSignals.tcl BuildNameListString.tcl ReportConnectionPoints.tcl ReportConnectorEnds.tcl GenerateHTMLReport.tcl] {
    if { [catch { source [file join $scriptDir $inc] } err] } {
       std::Output "error while loading $inc: $err\n"
    }
  }

  # This side effect is required for later report generation
  set addin::roots [list [std::GetModels -kind U2 -project $curProject]]

  GenerateHTMLReport
}
