/*************************************************************
Generated for IBM Rational Tau 4.3.0.0.15182 at Wed Sep 30 04:38:28 MEST 2009
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
// IBM Rational Tau Studio C++ Interfaces
// -----------------------------------
#ifndef __STUDIOACCESSINTERFACES_H
#define __STUDIOACCESSINTERFACES_H

#include "TauAPICommon.h"

#ifdef WIN32
#ifndef _STD_EXT_DATA
#define _STD_EXT_DATA __declspec(dllimport)
#endif
#else
#ifndef _STD_EXT_DATA
#define _STD_EXT_DATA
#endif 
#endif


namespace u2
{
    class ITtdProject;

    class _STD_EXT_DATA ITtdWorkspace : public IUnknown
    {
    public:
        virtual void GetPath(tstring& strPath) = 0;
        virtual ITtdProject* GetProject(const tstring& strPath) = 0;
        virtual ITtdProject* GetActiveProject() = 0;
        virtual void SetActiveProject(ITtdProject* pProject) = 0;

        static const GUID guid;
    };

    class _STD_EXT_DATA ITtdProject : public IUnknown
    {
    public:
        virtual void GetPath(tstring& strPath) = 0;
        virtual void GetName(tstring& strName) = 0;
        virtual IUnknown* GetModel() = 0;

        static const GUID guid;
    };

    class _STD_EXT_DATA ITtdStudioAccess : public IUnknown
    {
    public:
        // Execute the command with the specified name. If the specified command does not exist
        // an API error will be thrown.
        virtual void ExecuteNamedCommand(const tstring& commandName) const throw(APIError) = 0;

        virtual void GetProperty(const tstring& propertyName, tstring& value) const throw(APIError) = 0;
        virtual void SetProperty(const tstring& propertyName, const tstring& value) const throw(APIError) = 0;
        virtual ITtdWorkspace* OpenWorkspace(const tstring& path) const throw(APIError) = 0;
        virtual ITtdWorkspace* NewWorkspace(const tstring& path) const throw(APIError) = 0;
        virtual ITtdProject* OpenProject(const tstring& path) const throw(APIError) = 0;
        virtual IUnknown* GetSelection() const = 0;
        virtual ITtdWorkspace* GetWorkspace() const = 0;
        virtual void InterpretTclScript(const tstring& script, tstring& result) const throw(APIError) = 0;
        virtual void GetApplicationName(tstring& name) const = 0;
        virtual void GetApplicationPID(tstring& pid) const = 0;
        virtual void GetApplicationVersion(tstring& version) const = 0;
        virtual void GetApplicationUserName(tstring& username) const = 0;
        virtual void ShowApplication() const = 0;

        static const GUID guid;
    };

}

#endif __STUDIOACCESSINTERFACES_H
